# -*- coding: utf-8 -*- 

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from mil.service import restful

# NOTE: Decorators order is important. It must be:
#      @auth.rest_login()
#      @restful()


@auth.rest_login()
@restful()
def bug():
    def GET(*args, **vars):
        from project.rest import rest_bug_get
        return rest_bug_get(args)
    return locals()

@auth.rest_login()
@restful()
def incidence():
    def GET(*args, **vars):
        from project.rest import rest_incidence_get
        return rest_incidence_get(args)
    return locals()

@auth.rest_login()
@restful()
def project():
    def GET(*args, **vars):
        from project.rest import rest_project_get
        return rest_project_get(args)
    return locals()

@auth.rest_login()
@restful()
def roadmap():
    def GET(*args, **vars):
        from project.rest import rest_roadmap_get
        return rest_roadmap_get(args)
    return locals()

@auth.rest_login()
@restful()
def task():
    def GET(*args, **vars):
        from project.rest import rest_task_get
        return rest_task_get(args)
    return locals()
