# -*- coding: utf-8 -*- 

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from mil.tools import get_request_args

# Data Model
from system.dashboard import DashBoard, _decode_dict
dashb = DashBoard(db)
try:
    dashb.define_table()
except: # table exists
    pass

from dashboard import DASHBOARD_BOXES, DASHBOARD_DEFAULT_BOXES, caja1, caja2, \
caja3, caja4

@auth.requires_login()  
@_environ.is_in_app('public')
@_menu.showme()
def index():
    from gluon.contrib import simplejson as json
    
    form = SQLFORM.factory(submit_button=T('Save'))
    
    if form.accepts(request.vars,session):
        if request.vars.default_or_not == "true":
            new_list = json.dumps(DASHBOARD_DEFAULT_BOXES)
        else:        
            new_items = []
            for item in request.vars:
                if not item.startswith("_") and item != "default_or_not":
                    new_items.append(item)            
            new_list = dashb.get_new_boxes_list(new_items,auth.user)

        db(db.dashboard.user_identifier == auth.user.identifier).update(dashboard_boxes = new_list)
        
                    
        
        
    
    user_name = auth.user.first_name #db(db.auth_user.email == auth.user.email).select().first()["first_name"]

    row = db(db.dashboard.user_identifier == auth.user.identifier).select(db.dashboard.ALL).first()

    if not row:
        center_column = DASHBOARD_DEFAULT_BOXES["center_column"]
        right_column = DASHBOARD_DEFAULT_BOXES["right_column"]
        db.dashboard.insert(user_identifier = auth.user.identifier, dashboard_boxes = json.dumps(DASHBOARD_DEFAULT_BOXES))
    else:
        item = json.loads(row["dashboard_boxes"], object_hook=_decode_dict)
        center_column =item["center_column"]
        right_column =item["right_column"]
    
    
    user_boxes = []
    
    
    for item in right_column:
        user_boxes.append(item["box"])
    for item in center_column:
        user_boxes.append(item["box"])    
    

    
    return dict(form = form,
                center_column = center_column, 
                right_column = right_column,
                dashboard_boxes = DASHBOARD_BOXES,
                user_boxes = user_boxes, 
                user_name = user_name)

@auth.requires_login() 
@_environ.is_in_app('public')
def save_data():
    from gluon.contrib import simplejson as json    
    db(db.dashboard.user_identifier == auth.user.identifier).update(dashboard_boxes = request.vars.boxes)
    pass
    
#
#    INICIO DE LOS WIDGETS DEL DASHBOARD
#

@auth.requires_login() 
@_environ.is_in_app('public')
def load():
    id = request.vars.id
    min_max = request.vars.min_max or "max"
    data='Contenido de %s (valor por defecto)' % id
    
    try:
        # We define a map array
        case = {
            'caja1': caja1,
            'caja2': caja2,
            'caja3': caja3,
            'caja4': caja4,
            }
        data = case[id]()
        response.view = 'dashboard/%s.load' % id
    except Exception, e:
        data = 'Error: %s' % str(e)
    
    return dict(id=id, 
                header=DASHBOARD_BOXES[id], 
                data=data,
                min_max = min_max)

@auth.requires_login() 
@_environ.is_in_app('public')
def active_admin():
    [controller, params] = get_request_args(1)
    if controller is None:
        controller = 'default'
        
    response.cookies['admin_mode'] = 'administration'
    _environ.set('administration')
    
    # Save into user configuration
    if _user.is_logged:    
        preferences = _user.preferences
        preferences['admin_mode'] = 'administration'
        _user.set_preferences(preferences)
    
    if len(params) > 1:
        function = params[0]
        del(params[0])
        dest_url = URL(c=controller,f=function, args=params)
    elif len(params) == 1:
        dest_url = URL(c=controller,f=params[0])
    else:
        dest_url = URL(c=controller, f='index')
    
    
    redirect(dest_url)
    
@auth.requires_login() 
@_environ.is_in_app('public')
def deactive_admin():
    [controller, params] = get_request_args(1)
    if controller is None:
        controller = 'default'
        
    response.cookies['admin_mode'] = None
    _environ.set()
    
    # Save into user configuration
    if _user.is_logged:    
        preferences = _user.preferences
        preferences['admin_mode'] = None
        _user.set_preferences(preferences)
    
    if len(params) > 1:
        function = params[0]
        del(params[0])
        dest_url = URL(c=controller,f=function, args=params)
    elif len(params) == 1:
        dest_url = URL(c=controller,f=params[0])
    else:
        dest_url = URL(c=controller, f='index')
    
    
    redirect(dest_url)
  