# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon.serializers import json

from mil.tools import get_request_args

@_environ.is_in_app('public')
def index():
    # Private area
    if _user.is_logged:    
        # Admin Mode
        preferences = _user.preferences
        if 'admin_mode' in preferences.keys():
            _environ.set(preferences['admin_mode'])
        else:
            if 'admin_mode' in request.cookies:
                _environ.set(request.cookies['admin_mode'].value)      
        if session._next_url:
            next_url = session._next_url
            del session._next_url
            redirect(next_url)
        else:
            redirect(URL(r=request,c='dashboard',f='index'))
    else:   
        _environ.set()
        if _config.get('forge_private'):
            redirect(URL(r=request,c='default',f='user', args=['login']))
        else: 
            redirect(URL(r=request,c='public',f='index'))
 
@_environ.is_in_app('public')
def user():
#    _syslog.error('Test error', 'warning')
    is_login_page = True if request.args[0] == "login" else False
    
    if request.vars._next:
        if not session._next_url:
            session._next_url = request.vars._next
    return dict(form=auth(), is_login_page=is_login_page)
  

#def download():
#    """
#    allows downloading of uploaded files
#    http://..../[app]/default/download/[filename]
#    """
#    return response.download(request,db)
#
#
#def call():
#    """
#    exposes services. for example:
#    http://..../[app]/default/call/jsonrpc
#    decorate with @services.jsonrpc the functions to expose
#    supports xml, json, xmlrpc, jsonrpc, amfrpc, rss, csv
#    """
#    return service()
 
