# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

import re
import os.path

from gluon.storage import Storage

from mil.base import File

@auth.requires_login()
@auth.requires_membership('admin')
def index():
    _menu.show()
    # Error log path
    errorlog_path = os.path.join(_config.get('filesystem_path'), 
                                 'logs',
                                 'error.log')
    # Return value
    data = []
    if File.exists(errorlog_path):
        # If file exists,  get content
        content = File.readlines(errorlog_path)
        # Prepare data, line by line
        pattern = r"(\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}.\d{6}) \[(\w*)\] (.*)"
        for line in content:
            tmp = re.findall(pattern, line)
            if tmp:
                data.append(Storage(time=tmp[0][0],
                                    label=tmp[0][1],
                                    text=tmp[0][2]))
    else:
        response.flash = T('Error log file not exists')
    return dict(data=data)