# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

#
## Menu
#_menu.controller={'name': T('Files'),
#                  'module': 'file',
#                  'function': 'index'}

from mil.base import File
from mil.tools import get_request_args


@auth.requires_login()
@_menu.showme() 
def index():
    return dict()

def files():        
    elf_opts = {
         'root': _user.get_folder_path(),
         'URL': URL(r=request,c='file',f='file'),
         'debug': False,                   # enviar la información debug
         'fileURL': True,
#         'dirSize': True,                 # calcular el tamaño de los directorios
#         'dotFiles': True,                # mostrar ficheros cuyo nombre empieza por punto
#         'perms': {
#             '^/upload/.*': {             # en este directorios se pueden subir los ficheros
#                 'read': False,
#                 'write': False,
#                 'rm': False
#             },
#             'backup': {                  # prohibir modificar o eliminar los backups
#                 'read': True,
#                 'write': False,
#                 'rm': False
#             },
#             '^/secure': {                # cerrar completamente el acceso
#                 'read': False,
#                 'write': False,
#                 'rm': False
#             }
#         },
#         'uploadDeny': ['image', 'application'],      # prohibir subir las imágenes y programas
#         'uploadAllow': ['image/png', 'image/jpeg'],  # permitir subir jpg y png
#         'uploadOrder': ['deny', 'allow']
    }
 
#    import elfinder.core
#    elf = elfinder.core.connector(elf_opts)
    from elfinder import elFinderConnector, ELFINDERDRIVER
    elf = elFinderConnector(ELFINDERDRIVER.FS, elf_opts)
    
    # fetch only needed GET/POST parameters
    httpRequest = {}
    for field in elf.get_http_allowed_parameters():
        if field in request.vars:
            httpRequest[field] = request.vars[field]
            if field == 'upload[]':
                upFiles = {}
                cgiUploadFiles = request.vars['upload[]']
                for up in cgiUploadFiles:
                    if up.filename:
                        upFiles[up.filename] = up.file # pack dict(filename: filedescriptor)
                httpRequest['upload[]'] = upFiles
            
    # run connector with parameters
    try:
        elf_status, elf_header, elf_response = elf.run(httpRequest)
    except Exception, e:
        elf_status = 500 
        elf_header = []
        elf_response = None       
    
    # Output must be json always
    if elf_status == 200:
        data = elf_response
    else:
        data = {'error': 'Error code %s' % elf_status}
        
    for h, v in elf_header.iteritems():
        response.headers[h] = v
            
    from gluon.serializers import json
    if elf_header['Content-type'] == 'application/json':    
        return json(data)
    else:   
        return dict(data=json(data))        

def file():
    if len(request.args) > 0:
        parameters = "/".join(request.args)
        
    file_path = os.path.join(_user.get_folder_path(), parameters)
    if File.exists(file_path):
        from gluon.contenttype import contenttype
        file_name = os.path.basename(file_path)
        file_type = contenttype(file_name) or 'txt'
        response.headers['Content-Type'] = file_type
        return File.load(file_path)
    else:
        from gluon.http import HTTP
        raise HTTP(404) 
#    
#
#
#from services.file import FileModel
#
#@auth.requires_login()
#@_menu.showme() 
#def index():
#    insClass = FileModel(db)
#   
#    return dict(project='project_id',list=insClass.get_all())
#
#@auth.requires_login()
#@_menu.showme() 
#def load(): 
#    insClass = FileModel(db)
#    return dict(form=insClass.get_load_form())

def download():
    [file,params] = get_request_args(1) 
    
    from services.file import FileModel
    insClass = FileModel(db)
    
    if not file: 
        raise HTTP(404) 
    try:
        document = insClass.get_file(file)
#        document = db(db.file.identifier==file).select(db.file.deleted,db.file.file_content,db.file.file_name,db.file.file_format).first()
    except:
        raise HTTP(404) 
    
    if document.deleted == None:
        from gluon.contenttype import contenttype
        response.headers['Content-Type'] = contenttype(document.file_format) or 'txt'
        response.headers['Content-disposition'] = 'attachment; filename=%s' % (document.file_name)
        file_path=os.path.join(current._config.app_path,'uploads',document.file_content)
        return File.load(file_path)
    else:
        raise HTTP(404) 
    
def show():
    [project, file, params] = get_request_args(2) 
    
    from services.file import FileModel
    insClass = FileModel(db)
    
    if not file: 
        raise HTTP(404) 
    try:
        document = insClass.get_file(file)
        #db(db.file.identifier==file).select(db.file.deleted,db.file.file_content,db.file.file_name,db.file.file_format).first()
    except:
        raise HTTP(404) 
    
    if document.deleted == None:
        if document.file_format in ['png','jpeg','gif']:
            type='img'
        else:
            redirect(URL(r=request,c='file',f='download',args=[file]))
        return dict(type=type,file=document.file_content)
    else:
        raise HTTP(404) 
    
##def visible():
##    [name,file,params] = get_request_args(2) 
##    
##    if not file: 
##        redirect(URL(r=request,c='file',f='index',args=[name]))
##
##    document = db((db.file.project==name) & (db.file.name== file)).update(deleted=None)
##    redirect(URL(r=request,c='file',f='index',args=[name]))
##
##def hide():
##    [name,file,params] = get_request_args(2) 
##    
##    if not file: 
##        redirect(URL(r=request,c='file',f='index',args=[name]))
##    
##    import datetime
##    # Auxiliares
##    now=datetime.datetime.today()
##
##    document = db((db.file.project==name) & (db.file.name== file)).update(deleted=now)
##    redirect(URL(r=request,c='file',f='index',args=[name]))
##    
##    
##def delete():
##    [name,file,params] = get_request_args(2) 
##
##    if not file: 
##        redirect(URL(r=request,c='file',f='index',args=[name]))    
##
##    db((db.file.project==name) & (db.file.name== file)).delete()    
##    redirect(URL(r=request,c='file',f='index',args=[name]))