# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from mil.tools import get_request_args
from masters.users import Users

@auth.requires_login()
@auth.requires_membership('admin')
@_environ.is_in_app('administration')
def index():    
    _menu.show()
    
    users = Users(_config, db)
    form = users.grid()
    return dict(form=form)

@auth.requires_login()
@auth.requires_membership('admin')
def aprove():
    [id, params] = get_request_args()
    users = Users(_config, db)
    users.aprove(id)
    
    redirect(URL(r=request, f="index"))

@auth.requires_login()
@auth.requires_membership('admin')
def reject():
    [id, params] = get_request_args()
    users = Users(_config, db)
    users.reject(id)

    redirect(URL(r=request, f="index"))

@auth.requires_login()
@auth.requires_membership('admin')
def enable():
    [id, params] = get_request_args()
    users = Users(_config, db)
    users.enable(id, True)

    redirect(URL(r=request, f="index"))

@auth.requires_login()
@auth.requires_membership('admin')
def disable():
    [id, params] = get_request_args()
    users = Users(_config, db)
    users.enable(id, False)

    redirect(URL(r=request, f="index"))
    
@auth.requires_login()
@auth.requires_membership('admin')
def set_admin():
    [id, params] = get_request_args()
    
    if current.auth.has_membership('admin', id):
        gp_id = current.auth.id_group('admin')
        current.auth.del_membership( gp_id, id)
    else:
        current.auth.add_membership('admin', id)

    redirect(URL(r=request, f="index"))