# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

def index():
    redirect(URL(r=request,c='default',f='index'))
    return dict()

@auth.requires_login()
@auth.requires_membership('admin')
def service():
    _menu.controller={'name': T('Service'),
                      'module': 'master',
                      'function': 'service'}
    _menu.show()
    
    from masters.services import Services
    insKlss = Services(db) 
    return dict(form=insKlss.grid())


@auth.requires_login()
@auth.requires_membership('admin')
def save_pts():
    from masters.projecttype import ProjectTypeServices
    insKlss = ProjectTypeServices(db) 
    insKlss.save_data()
    return dict(ok=dict())

@auth.requires_login()
@auth.requires_membership('admin')
def boxes():
    _menu.controller={'name': T('Available Boxes'),
                      'module': 'master',
                      'function': 'boxes'}
    _menu.show()
    
    from masters.boxes import Boxes
    insKlss = Boxes(db) 
    return dict(form=insKlss.grid())

@auth.requires_login()
@auth.requires_membership('admin')
def tags():
    _menu.controller={'name': T('Tags'),
                      'module': 'master',
                      'function': 'tags'}
    _menu.show()
    
    from masters.tags import Tags
    insKlss = Tags(db) 
    return dict(form=insKlss.grid())

@auth.requires_login()
@auth.requires_membership('admin')
def actions():
    _menu.controller={'name': T('Pending actions'),
                      'module': 'master',
                      'function': 'actions'}
    _menu.show()
    
    from masters.actions import Actions
    insKlss = Actions(db) 
    return dict(form=insKlss.grid())

@auth.requires_login()
@auth.requires_membership('admin')
def flows():
    _menu.controller={'name': T('Flows'),
                      'module': 'master',
                      'function': 'flows'}
    _menu.show()
    
    from masters.flows import FlowSteps
    insKlss = FlowSteps(db) 
    return dict(insKlss.get())

@auth.requires_login()
@auth.requires_membership('admin')
def flow_steps():
    _menu.controller={'name': T('Flow Step'),
                      'module': 'master',
                      'function': 'flow_steps'}
    _menu.show()
    
    from masters.flows import Steps
    insKlss = Steps(db) 
    return dict(form=insKlss.grid())

@auth.requires_login()
@auth.requires_membership('admin')
def flow_handler():
    _menu.controller={'name': T('Flow'),
                      'module': 'master',
                      'function': 'flow_handler'}
    _menu.show()
    
    from masters.flows import Flows
    insKlss = Flows(db) 
    return dict(form=insKlss.grid())

@auth.requires_login()
@auth.requires_membership('admin')
def save_flow():
    from masters.flows import FlowSteps
    insKlss = FlowSteps(db) 
    insKlss.save_data()
    return dict(ok=dict())

@auth.requires_login()
@auth.requires_membership('admin')
def logs():
    _menu.controller={'name': T('Logs'),
                      'module': 'master',
                      'function': 'logs'}
    _menu.show()
    _syslog.log('Master.logs access')
    from masters.logs import Logs
    insKlss = Logs(db) 
    return dict(form=insKlss.grid())
