# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from mil.tools import get_request_args

from masters.profiles import Profiles

@auth.requires_login()
@auth.requires_membership('admin')
@_menu.showme()
def index():
    insKlss = Profiles(_config, db)
    form = insKlss.grid()
    return dict(form=form)

@auth.requires_login()
@auth.requires_membership('admin')
@_menu.showme()
def configure():
    [id,params] = get_request_args(1)
    
    insKlss = Profiles(_config, db)
    profile = insKlss.get(id)
    
    from service import ServiceManager
    from system import AuthConfiguration
    
    smng = ServiceManager("masters")
    auth_mng = AuthConfiguration(db, profile.id)
    data = None
    
    if len(request.vars) > 0:
        all_data = smng.get_all_as_dict(auth_mng)
        for data in all_data:
            auth_mng.delete(data['id'])
            for action in data['actions']:
                if action['id'] in request.vars:
                    auth_mng.add(data['id'], 
                                 action['id'], 
                                 request.vars[action['id']])
    
    data = smng.get_all_as_dict(auth_mng)
#    if id in smng.services.keys():
#        data = smng.get_as_dict(id, auth_mng) 
    
    return dict(profile=profile,all_data=data)