# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon.serializers import json

from mil.tools import get_request_args

@_environ.is_in_app('public')
def index():
    # User's projects
    try:
        from project import ProjectHandler
        from project.models.card import ProjectCardModel
        rows = ProjectCardModel(db).get_all_public_ids()        
        list = []
        for row in rows:            
            list.append(ProjectHandler.prepare_card(row.id))
    except Exception, e:
        list = []    
    return dict(list=list,user=_user)
    
def info():
    [page, params] = get_request_args(1)
    
    if page == 'about':
        page_path = 'about.html'
    elif page == 'disable':
        page_path = 'disable.html'
    else:
        page_path = '404.html'
        
    response.view = "default/%s" % page_path
    return dict()
