# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from mil.tools import get_request_args
from masters.workflows import WorkFlows

@auth.requires_login()
@auth.requires_membership('admin')
@_menu.showme()
def index():
    insClass = WorkFlows(db)
    form = insClass.grid()
    return dict(form=form)

@auth.requires_login()
@auth.requires_membership('admin')
@_menu.showme()
def configure():
    [id, params] = get_request_args()
    insClass = WorkFlows(db)
    data = insClass.get_by_id(id)
    return dict(flow=data)

@request.restful()
@auth.requires_login()  
def api():
    def GET(*args, **vars):  
        [id, params] = get_request_args()  
        insClass = WorkFlows(db)
        data = insClass.get_by_id(id)  
        
        current.response.headers['Content-Type'] = 'application/json'
        return XML(data.content)
        #return XML(json(mn.get_menu_rest()))          
        
    def POST(*args, **vars): 
        # Needed One argument
        if len(args) != 1:
            raise HTTP(400) 
        else:
            [id, params] = get_request_args()
        
        json_data = request.body.read()
        # Check if json string is valid
        is_valid = False
        import gluon.contrib.simplejson as json
        try:
            data = json.loads(json_data)
            is_valid = True
        except Exception, e:
            data = None
        if is_valid:
            insClass = WorkFlows(db)
            data = insClass.set_by_id(id, json_data)              
        else:
            raise HTTP(400) 
        
    return locals()
