# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

if _config is not None:
    response.title = _config.get('title') or 'OpenMyWork Forge 2.0'
    response.logo = _config.get('logo') or URL(r=request,
                                               c='static',
                                               f='images/omw_logo_30h.png')
    response.favicon = _config.get('favicon') or URL(r=request,
                                                     c='static',
                                                     f='images/favicon.ico')
    response.subtitle = _config.get('subtitle') or T('Collaborative Workspace')
    
    ## read more at http://dev.w3.org/html5/markup/meta.name.html
    response.meta.author='cajacomun'
    response.meta.description = 'collaborative workspace'
    response.meta.keywords = 'web2py, python, framework'
    response.meta.generator = 'Web2py Web Framework'
    response.meta.copyright = 'Copyright 2011'
    
    response.visual_style = _config.get('visual_style') or 'base'
    
    ##########################
    # Language
    # User languaje
    language = _config.get('language')
    if _user is not None:
        if _user.preferences.has_key('lang'):
            language = _user.preferences['lang']
    response.language =  language or 'en-en'
    response.language_i18n = _config.get('language')[0:2] or 'en'
    T.force(response.language)
    
    ##########################
    # Menu
    response.menu = [  ]
    from core.menuhandler import MenuHandler
    _menu = MenuHandler()
    # User available using web2py current instance
    current._menu = _menu
