# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon import *

class CalendarHandler(object): 
    @staticmethod
    def get_css_classes():
#        query = (db.user_calendars.user_id == auth.user.id)
#        results = db(query).select()
    
        css_classes = []
#        for result in results:
#            css_classes += [create_css_class(result.as_dict())]
    
        return css_classes
           
    @staticmethod
    def get_calendar_by_name(name):
        from calendar.models.calendar import CalendarModel
        return CalendarModel(current.db).get_by_name(name)        
           
    @staticmethod
    def create_calendar(name, parent_id):
        from calendar.models.calendar import CalendarModel
        insKlass = CalendarModel(current.db)
        calendar = insKlass.get_by_name(name)
        if calendar is None:
            return insKlass.add(name, parent_id)
        else:
            return False
        
    @staticmethod
    def delete_calendar(name):
        # Get Calendar
        from calendar.models.calendar import CalendarModel
        cmKlass = CalendarModel(current.db)
        cal_id = cmKlass.get_by_name(name).id
        
        # Delete calendar events
        from calendar.models.event import EventModel        
        evlass = EventModel(current.db)        
        evlass.delete_by_calendar(cal_id)
        
        # Delete user connections
        from calendar.models.user_calendar import UserCalendarModel        
        ucmKlass = UserCalendarModel(current.db)        
        ucmKlass.delete_by_calendar(cal_id)
        
        # Delete calendar
        cmKlass.delete(cal_id)
    
    @staticmethod
    def can_modify_calendar(calendar_id):
        from calendar.models.user_calendar import UserCalendarModel
        insKlass = UserCalendarModel(current.db)        
        return insKlass.get_permission(calendar_id, current._user.id)
    
    @staticmethod
    def assign_user_as_owner(calendar_id, user_id):
        from calendar.models.user_calendar import UserCalendarModel
        insKlass = UserCalendarModel(current.db)        
        return insKlass.add_owner(user_id, calendar_id)
    
    @staticmethod
    def assign_user(calendar_id, user_id, permission):
        if not permission in ['r', 'rw', 'owner']:
            raise Exception(current.T('Invalid permissions'))
        
        from calendar.models.user_calendar import UserCalendarModel
        insKlass = UserCalendarModel(current.db)        
        return insKlass.add_user(user_id, calendar_id, permission)
    
    @staticmethod
    def unassign_user(calendar_id, user_id):        
        from calendar.models.user_calendar import UserCalendarModel
        insKlass = UserCalendarModel(current.db)        
        return insKlass.remove_user(user_id, calendar_id)
    
    @staticmethod
    def add_event(**kwargs):
        from calendar.models.event import EventModel
        insKlass = EventModel(current.db)
        return insKlass.add(**kwargs)
           
        


#def create_user_rel(form):
#    db.user_calendars.insert(calendar=form.vars.id, color="blue", fullcalendar_class="fc_cal_id"+str(form.vars.id)+"_uid"+str(auth.user.id),permissions="owner",user_id=auth.user.id)
#
#
#def get_css_classes():
#    query = (db.user_calendars.user_id == auth.user.id)
#    results = db(query).select()
#
#    css_classes = []
#    for result in results:
#        css_classes += [create_css_class(result.as_dict())]
#
#    return css_classes
#
#def create_css_class(c):
#
#    css_class = ".%s, .fc-agenda .holiday .fc-event-time, .%s a {" % (c["fullcalendar_class"],c["fullcalendar_class"])
#
#    #set text color depending the background color
#    text_color = "#000000"
#    if toHex(c["color"]) < toHex("888888"):
#        text_color = "#FFFFFF"
#
#    css_class += "background-color: #%s; border-color: #%s; color: %s;} " % (c["color"], c["color"], text_color)
#    return css_class
#
#def get_event(event_id):
#    query = ((db.events.id == event_id))
#    return db(query).select()[0]
#
#def can_modify(event):
#    query = ((db.user_calendars.calendar == event.calendar_id) & (db.user_calendars.user_id == auth.user.id))
#    result = db(query).select()
#    if len (result) != 1:
#        return False
#
#    return result[0].permissions == "rw" or result[0].permissions == "owner"
#
#def _modify_event ( event, dayDelta, minuteDelta, allDay, resizeOrDrop):
#    from datetime import timedelta
#
#    if resizeOrDrop == "resize":
#        event.end_date = event.end_date + timedelta(days = int(dayDelta), minutes = int(minuteDelta))
#    else:
#        event.init_date = event.init_date + timedelta(days = int(dayDelta), minutes = int(minuteDelta))
#        event.end_date = event.end_date + timedelta(days = int(dayDelta), minutes = int(minuteDelta))
#    if allDay != None:
#        ad = False
#        if allDay == 1:
#            ad = True
#        event.all_day = ad
#    event.update_record()
#
#    return
#    #event.init_date.timedelta()
#
#def set_cal_id_actions(calendar_id):
#    if can_modify_calendar(calendar_id):
#        return DIV(A(T('Edit'),_href=URL(r=request, f='configure', args=(calendar_id)))," ", A(T('Delete'),_onclick="return confirm('" + T("Are you sure to delete?")+"')",_href=URL(r=request, f='delete', args=(calendar_id))))
#    else:
#        return DIV(A(T('Edit'),_href=URL(r=request, f='configure', args=(calendar_id))))
#
#def set_event_id_actions(event_id):
#    calendar_id = db(db.events.id == event_id).select()[0].calendar_id
#    if can_modify_calendar(calendar_id):
#        return DIV(A(T('Edit'),_href=URL(r=request, f='update', args=(event_id)))," ", A(T('Show'),_href=URL(r=request, f='read', args=(event_id)))," ",A(T('Delete'),_onclick="return confirm('" + T("Are you sure to delete?")+"')",_href=URL(r=request, f='delete', args=(event_id))))
#    else:
#        return DIV(A(T('Show'),_href=URL(r=request, f='read', args=(event_id))))
#

#
##convert string to hex
#def toHex(s):
#    lst = []
#    for ch in s:
#        hv = hex(ord(ch)).replace('0x', '')
#        if len(hv) == 1:
#            hv = '0'+hv
#        lst.append(hv)
#
#    return reduce(lambda x,y:x+y, lst)
#
##convert hex repr to string
#def toStr(s):
#    return s and chr(atoi(s[:2], base=16)) + toStr(s[2:]) or ''
#
#
#def get_in_fixed_list(data, expected=None):
#    expected_args = []
#    arguments = data
#
#    if expected is None:
#        expected = len(arguments)
#
#    for item in range(expected):
#        try:
#            value = request.args(item)
#        except:
#            value = None
#        expected_args.append(value)
#    if expected < len(arguments):
#        expected_args.append(arguments[expected:])
#    else:
#        expected_args.append([])
#    return expected_args
    