# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon import current

from mil.tools import get_request_args

from core.subapplication import SubApp, SubAppModule

from calendar import CalendarHandler
from calendar.models.calendar import CalendarModel

class CalendarManagement(SubAppModule):
    def __init__(self):
        SubAppModule.__init__(self, 'calendar', 'management')
        
    def index(self):
        current._menu.show()
        insKlss = CalendarModel(current.db) 
        return dict(form=insKlss.grid())
    
    def configure(self):
        current._menu.show()
        
        [cal_id, temp] = get_request_args()
        
        from calendar.models.user_calendar import UserCalendarModel
        insKlass  = UserCalendarModel(current.db)
        form = insKlass.configure_form(cal_id)
        if form.accepts(current.request.vars):
            insKlass.configure_update( cal_id, **dict(form.vars))
            current.response.flash = current.T('Calendar updated')
            redirect(URL(c='calendar', f='management'))
        
        return dict(form=form)

        
    