# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon import *

class CalendarModel(object):
    @staticmethod
    def define_table(db):        
        if 'calendar' in db.tables:
            return

        db.define_table('calendar',
                        Field('name', 'string', 
                              required=True, notnull=True),
                        Field('parent_id', 'string', default="", 
                              required=True),
                        format='%(name)s')

    def __init__(self, db):
        self.db = db
        
        CalendarModel.define_table(db)
        
    def grid(self):# Links
        def link_configure(r):
#            if can_modify_calendar(calendar_id):
#                return DIV(A(T('Edit'),_href=URL(r=request, f='configure', args=(calendar_id)))," ", A(T('Delete'),_onclick="return confirm('" + T("Are you sure to delete?")+"')",_href=URL(r=request, f='delete', args=(calendar_id))))
#            else:
#                return DIV(A(T('Edit'),_href=URL(r=request, f='configure', args=(calendar_id))))
            return A(current.T('Configure'),
                     _href=URL(r=current.request, 
                               c="calendar", 
                               f="management", 
                               args=['configure', r.id])) 
            
        form = SQLFORM.grid(self.db.calendar, 
                            searchable=False,
                            details=False,
                            csv=False, 
                            user_signature = False,
                            maxtextlength=100,
                            links=[lambda r:link_configure(r)])
        return form
    
    
    def add(self, name, parent_id):
        return self.db.calendar.insert(name=name, parent_id=parent_id)
    
    def delete(self, id):
        return self.db(self.db.calendar.id== id).delete()
        
    def get_by_name(self, name):
        return self.db(self.db.calendar.name == name).select().first()