# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon import current, URL
from gluon.storage import Storage

from core.subapplication import SubAppInstance

class CalendarInstance(SubAppInstance):
    def __init__(self):
        SubAppInstance.__init__(self, 'calendar')
        
    def get_menu(self):
        return [(current.T('Calendars'), False, None, [
                    (current.T('Calendar'), False, 
                     URL(current.request.application,'calendar','index',args=['public']), []),
                    (current.T('List'), False, 
                     URL(current.request.application,'calendar','management'), []),
                    (current.T('User List'), False, 
                     URL(current.request.application,'calendar','user'), []),
                    (current.T('Event'), False, 
                     URL(current.request.application,'calendar','event'), []),
#                    (current.T('Reminder'), False, 
#                     URL(current.request.application,'calendar','reminder'), [])
                 ])
               ]
        
    def set_services(self):
        data = []
        data.append(Storage(id='calendar', 
                            function='calendar',
                            label='Calendar', 
                            default=True))
        return data  
        
    
        
    def get_configuration(self):
        try:            
            data = {}
            data['controller'] = self.name
        except Exception, e:
            data = None
            