# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################
import yaml

DOCUMENT = """
  configuration:
    system:
      label: 'Filesystem'
      id: system
      actions:  
        -
          label: 'User quota'
          id: user_quota
          type: only_one
          options:
            -
              id: disabled
              label: 'Disabled' 
              default: true
            -
              id: enabled 
              label: 'Enable' 
              default: false
    email:
      label: 'Email notification'
      id: email
      actions:       
        -
          label: 'Create User'
          id: add_user
          type: only_one
          options:
            -
              id: 'False'
              label: 'Do not send notification' 
              default: false
            -
              id: 'True'
              label: 'Send notification' 
              default: true     
        -
          label: 'Delete User'
          id: del_user
          type: only_one
          options:
            -
              id: 'False'
              label: 'Do not send notification' 
              default: false
            -
              id: 'True'
              label: 'Send notification' 
              default: true  
        -
          label: 'Change password'
          id: changed_password
          type: only_one
          options:
            -
              id: 'False'
              label: 'Do not send notification' 
              default: false
            -
              id: 'True'
              label: 'Send notification' 
              default: true
  literal: 'System'
"""

def get_configuration():
    try:
        return yaml.load(DOCUMENT)
    except Exception, e:
        raise(e)
