# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################
           
from gluon import *
from gluon.languages import lazyT

from mil.tools import normalize

try:
    ADMIN_MENU = [
#        (current.T('Masters'), False, None, [
##            (current.T('Government'), False, 
##             URL(current.request.application,'government','index'), 
##             []),                                 
##            (current.T('Guestbook'), False, 
##             URL(current.request.application,'guestbook','index'), 
##             []),  
##            (current.T('Services'), 
##             False, 
##             URL(current.request.application,'master','service'), [
##                    (current.T('Create Services'), 
##                     False, 
##                     URL(current.request.application,'master','service',
##                         args=['new', 'service']), [])
##            ]),
##            (current.T('Boxes'), 
##             False, 
##             URL(current.request.application,'master','boxes'), [
##                    (current.T('Create Boxes'), 
##                     False, 
##                     URL(current.request.application,'master','boxes',
##                         args=['new','available_boxes']), [])
##            ]),
##            (current.T('Flows'), 
##             False, 
##             URL(current.request.application,'master','flows'), [
##                    (current.T('Flow'), 
##                     False, 
##                     URL(current.request.application,'master','flow_handler',),
##                      []),    
##                    (current.T('Flow Step'), 
##                     False, 
##                     URL(current.request.application,'master','flow_steps'), 
##                     [])
##            ]),
##            (current.T('WorkFlows'), 
##             False, 
##             URL(current.request.application, 'workflow', 'index')),
##            (current.T('Pending actions'), 
##             False, 
##             URL(current.request.application,'master','actions')), 
##            (current.T('Tags'), 
##             False, 
##             URL(current.request.application,'master','tags')),  
##            (current.T('Languages'), 
##             False, 
##             URL(current.request.application, 'language','index')),   
##            (current.T('User Requests'), 
##             False, 
##             URL(current.request.application,'register','index')), 
##            (current.T('Logs'), 
##             False, 
##             URL(current.request.application,'master','logs')),    
#        ]),
        ]
    ##########################################
    ## User menu
    ##########################################
    BASE_MENU = [(current.T('Home'), False, URL(current.request.application,'dashboard','index'), [])]
    PUBLIC_MENU = [(current.T('Open Projects'), False, URL(current.request.application,'default','index'), [])]
except:
    ADMIN_MENU = []
    BASE_MENU = []
    PUBLIC_MENU = []
    
class MenuHandler:
    def __init__(self):
        self.controller=None      
        self.data=[]
        self.not_ready=True
        
    def _process(self):            
        # Done only once
        self.not_ready=False
        
        # Index by user profile    
        if current._user.identifier is None:
           self.data += PUBLIC_MENU
        else:
            self.data += BASE_MENU
#            if current._user.is_admin: #@auth.requires_membership('admin')
            if current.auth.has_membership(user_id=current._user.id, 
                                           role='admin'):
                self.data += ADMIN_MENU
#                if current._environ.is_in('administration'):
#                    self.data+=ADMIN_MENU
                try:
                    for subapp in current._config.get('subapp'):
                        mp = "applications.%s.modules.%s" % (current.request.application, 
                                                             subapp)
                        klass_name = "%sInstance" % subapp.capitalize()
                        try:
                            mod = __import__(mp, fromlist=[klass_name])
                            klass = getattr(mod, klass_name)
                            self.data += klass().get_menu()
                        except Exception, e:
                            literal = 'MenuHandler._process: %s' % str(e)
                            current._syslog.error(literal, 'warning')
                except:
                    # No subapplication defined
                    pass
           
#        # request check
#        if current.request.controller=='default' or current.request.controller=='desktop':
#            return
        
#        # Project element   
#        project=None
#        if current._user.pid:
#            try:
#                project = vip_project.get(current._user.pid)
#                project_menu=vip_project.get_menu_services(current._user.pid)
#                tmp=[]
#                for element in project_menu:
#                    if element.type == 'external':
#                        tmp.append((current.T(element.name), False, element.action, []))                        
#                    elif element.type == 'server':
#                        tmp.append((current.T(element.name), False, element.controller, []))                        
#                    else:
#                        tmp.append((current.T(element.name), False, URL(current.request.application,element.controller,element.function,args=[project.name]), []))
#                self.data += [(project.title, False, URL(current.request.application,'project_resume','index',args=[project.name]), tmp)]
#            except:
#                pass
#        
#        # Controller
#        if self.controller is not None:
#            try:    
#                if project is not None:
#                    self.data += [(current.T(self.controller['name']), False, URL(current.request.application,self.controller['module'],self.controller['function'],args=[project.name]), [])]
#                else:
#                    self.data += [(current.T(self.controller['name']), False, URL(current.request.application,self.controller['module'],self.controller['function']), [])]
#            except:
#                pass
            
        # Done only once
        self.not_ready=False
            
    def show(self):
        if self.not_ready:
            self._process()
        current.response.menu = self.data
        
    def show_forced(self):   
        self.data=[]
        self._process()
        current.response.menu = self.data   
        
    def showme(self):
        def wrapper(action,self=self):
            def f(_action=action,_self=self,*a,**b):
                self.show()
                return _action()
            f.__doc__ = action.__doc__
            f.__name__ = action.__name__
            return f
        return wrapper
    
class MENUIZER(object):
    def __init__(self, name, **args):
        self.name = name
        self.attributes = args
        
    def xml(self):
        return self._render()
        
    def _render(self):
        from gluon import current
        from gluon.template import render
        from gluon.storage import Storage
        import os

        filename = os.sep.join([current.request.folder+"views",
                                '_menu',
                                "%s.html"%self.name])
        
        if not os.path.exists(filename):
            return ""
        
        
        # Prepare attributes
        view_data = Storage()
        for item in self.attributes:
            view_data[item] = self.attributes[item]
        # Prepare Menu
        menu = []
        for item in current.response.menu:
            (name, active, link) = item[:3]
            item_data = Storage()
            
            item_data.type = 'element' 
            active_url = URL(current.request.controller, 
                             current.request.function)
            if active_url == link:
                item_data.active = True
            else:
                item_data.active = False
            item_data.href = link
            item_data.label = name
            item_data.submenu = []
            if len(item) > 3 and item[3]:
                item_data.type = 'submenu' 
                for subitem in item[3]:
                    (name, active, link) = subitem[:3]
                    submenu = Storage()
                    submenu.href = link
                    submenu.label = name                    
                    item_data.submenu.append(submenu)

            menu.append(item_data)
        view_data['menu'] = menu
        
        return render(filename=filename, context= view_data)
    
class PILLS(object):
    def __init__(self, **args):
        self.attributes = args
        
    def xml(self):
        return self._render()
        
    def _render(self):
        from gluon import current
        from gluon.template import render
        from gluon.storage import Storage
        import os

        filename = os.sep.join([current.request.folder+"views",
                                '_menu',
                                "pills.html"])
        
        if not os.path.exists(filename):
            return ""
        
        
        # Prepare attributes
        view_data = Storage()
        for item in self.attributes:
            view_data[item] = self.attributes[item]
        # Prepare Pills
        pills = []
        for item in current.response.pills:
            (name, link) = item[:3]
            item_data = Storage()   
            active_url = URL(current.request.controller, 
                             current.request.function, 
                             args=current.request.args)
            if active_url == link:
                item_data.active = True
            else:
                item_data.active = False
            item_data.href = link
            item_data.label = name

            pills.append(item_data)
        view_data['pills'] = pills
        
        
        return render(filename=filename, context= view_data)
    