# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon import current
from gluon.storage import Storage

from mil.system import startNotifierSystem, Notifier 

def startSystemNotifier():
    startNotifierSystem()
    
class SystemNotifier(Notifier):   
    def __init__(self):
        Notifier.__init__(self)
        
        self.event_types.append('error')
        
    def flow(self, *args, **kwargs):
        try:
            # flow name and user identifier must be first and second parameter
            flow = args[0]
            user = args[1]
            # other parameter are extra information
            data = Storage()
            for key in kwargs:
                data[key] =  kwargs[key]
    
            content = Storage(flow=flow, user=user, data=data)
            self.emit(content, event='flow')
        except Exception, e:
            current._syslog.error(e, 'warning')
            