# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon import current
from gluon.storage import Storage

DASHBOARD_BOXES = {"caja1": current.T("My Projects"),
                   "caja2": current.T("My Tasks"),
                   "caja3": current.T("My Bugs"),
                   "caja4": current.T("My Incidences"),
                   }

DASHBOARD_DEFAULT_BOXES = {
    "center_column": [{"box": "caja1", "min_max": "max"}, 
                      {"box": "caja2", "min_max": "max"}],
    "right_column": [{"box": "caja3", "min_max": "max"}, 
                     {"box": "caja4", "min_max": "max"}]}


PRIORITY = {'1': {'css_class': '27', 'label': current.T("Very low")},
            '2': {'css_class': '29', 'label': current.T("Low")},
            '3': {'css_class': '7', 'label': current.T("Medium")},
            '4': {'css_class': '3', 'label': current.T("High")},
            '5': {'css_class': '5', 'label': current.T("Very high")},
            '6': {'css_class': '13', 'label': current.T("Critical")}}     
def caja1():
    from project import ProjectHandler
    
    from project.models.team import ProjectTeamModel
    ProjectTeamModel.define_table(current.db)
    # User's projects
    query=((current.db.project_card.deleted==False) & \
           (current.db.project_card.id==current.db.project_team.project) & \
           (current.db.project_team.user==current._user.id) & \
           (current.db.project_card.active==False))
    rows = current.db(query).select(current.db.project_card.id,
                                    current.db.project_team.profile)

    list = []
    for row in rows:
        elem = ProjectHandler.prepare_card(row.project_card.id)
        elem.user_profile = row.project_team.profile
        list.append(elem)
    return Storage(list=list)

def caja2():
    from project.models.task import TaskModel
    tskIns = TaskModel(current.db)
    return Storage(user_data=tskIns.user_data(current._user.email),
                   priority=PRIORITY)
    
def caja3():
    from project.models.bug import BugModel
    tskIns = BugModel(current.db)
    return Storage(user_data=tskIns.user_data(current._user.email),
                   priority=PRIORITY)

def caja4():
    from project.models.incidence import IncidenceModel
    tskIns = IncidenceModel(current.db)
    return Storage(user_data=tskIns.user_data(current._user.email),
                   priority=PRIORITY)
    
#def caja3():    
##    current._syslog.error('Pruebas con timestamp', 'info')
#    flows_data=[]
#    from system import FlowInstance
#    fi = FlowInstance(current.db)
#    flows = fi.get_all_user(current.auth.user.identifier)
#    
#    from masters.workflows import WorkFlows
#    for flow in flows:
#        flow_data = WorkFlows(current.db).get_by_ident(flow.flow)
#        try:
#            flows_data.append(Storage(id=flow.flow, 
#                                      description=flow_data.description))
#        except:
#            literal = '%s "%s"' % (current.T('Unknown'), flow.flow)
#            flows_data.append(Storage(id=flow.flow, description=literal))
#            
#    
#    return Storage(flows=flows_data)
#
#def caja4():    
#    from project import ProjectHandler
#    
#    # Projects
#    from project.models.card import ProjectCardModel
#    projectKlass = ProjectCardModel(current.db)    
#    publics = projectKlass.get_all_public_ids()
#    
#    # User Projects
#    from project.models.team import ProjectTeamModel
#    teamKlass = ProjectTeamModel(current.db)
#    users = teamKlass.get_user_projects(current._user.id)
#
#    list = []
#    for row in publics:
#        if row.id not in users:
#            list.append(ProjectHandler.prepare_card(row.id))
#    return Storage(list=list)
