# -*- coding: utf-8 -*- 

import os
import yaml

from mil.base.storage import Storage
from mil.base.file import File, FileNotExists

class YAMLFile:    
    """
    This class implements the basic statics methods to handle a YAML formated string.
    """     
    @staticmethod          
    def loads(string):  
        """
        Returns data from a YAML formated string.

        Keyword arguments:
        string -- YAML formated string
        """
        return yaml.load(string)
    
    @staticmethod          
    def load(filename):  
        """
        Returns data from a YAML formated file.

        Keyword arguments:
        filename -- file name (path)
        """
        return yaml.load(File.load(filename))
        
    @staticmethod          
    def save(filename, data, sort=False):
        """
        Saves data in a YAML formated file.

        Keyword arguments:
        filename -- file name (path)
        data -- data to save in file
        sort -- data must be sorted (default is False)
        """
        if sort:
            data.sort()

        File.save(filename, yaml.dump(data, default_flow_style=False))
