# -*- coding: utf-8 -*- 
# Este fichero forma parte de mil
#
# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'licence' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.#!/usr/bin/env python

__all__ = ['md5Packed']

class md5Packed:
    def __init__(self, aKey,quoted='url'):
        self.key = aKey
        self.p_key = self._packed(aKey)    
        self.quoted=quoted
        
    def __call__(self, value):
        return self.crypt(value)
    
    def _packed(self,aValue):
        from hashlib import md5
        return md5(aValue).digest()
    
    def _joined(self,aString,aKey):
        """
        Encrypt/Decrypt the passed string object and return
        the encrypted string
        """
        kIdx = 0
        cryptStr = ""   # empty 'crypted string to be returned
        for x in range(len(aString)):
            cryptStr = cryptStr + chr( ord(aString[x]) ^ ord(aKey[kIdx]))
            # use the mod operator - % - to cyclically loop through the keyword
            kIdx = (kIdx + 1) % len(aKey)

        return cryptStr
    
    def crypt(self,aString):        
        from urllib import quote
        cryptStr = ""
        key1=self.p_key
        
        while(aString):
            m = aString[0:15]
            aString = aString[16:]
            cryptStr = cryptStr + self._joined(m,key1)
            key1 = self._packed("%s%s%s"%(self.key,key1,m))
            
        return (quote(cryptStr), None)
    
    def decrypt(self,aPassword):        
        from urllib import unquote
        aPassword = unquote(aPassword)
        cryptStr = ""
        key1=self.p_key
        
        while(aPassword):
            m = aPassword[0:15]
            aPassword = aPassword[16:]
            cryptStr = cryptStr + self._joined(m,key1)
            key1 = self._packed("%s%s%s"%(self.key,key1,m))
            
        return cryptStr

def md5packed_crypt(key,value):
    c_md5 = md5Packed(key)
    return c_md5(value)[0]

def md5packed_decrypt(key,value):
    c_md5 = md5Packed(key)
    return c_md5.decrypt(value)

class MD5PACKED:
    def __init__(self, key): self.key=key
    def __call__(self, value): md5packed_crypt(self.key,value)
    def formatter(self, value): md5packed_decrypt(self.key,value)
