# -*- coding: utf-8 -*- 

from handler import Handler
from mil.base import File, FileNotExists, Storage

class DBTableHandler(Handler):
    table_name = None
    type = 'DDBB Table'
    
    def __init__(self, **kwargs):
        table_name = kwargs.get('table', None)
        db = kwargs.get('db', False)
           
        if db is not None:
            self.db = db
            if not table_name in self.db.tables:
                self.table_name = table_name
                self.define_table(self.db)
        else:
            raise Exception('Must be db instance')
                
    def define_table(db): 
        raise NotImplementedError('This method must be implemented')
                    
    def __repr__(self):
        return "<Handler: %s (%s) >" % (self.type, self.table_name)    
            
    def load(self, id):  
        return self.get(id)
   
    def save(self, id, data):
        self.insert(id, data)
            
    def erase(self, id):
        self.delete(id)