# -*- coding: utf-8 -*- 

import exceptions

class isNotHandler(exceptions.Exception):
    name=''
    def __init__(self, name):
        self.name=name
        
    def __str__(self):
        print "'%s' not implements Handler interface."%self.name
        
class Handler:
    def get(self, id=None):
        if id is not None:
            return self._get_one(id)
        else:
            return self._get_all()
        pass
    
    def _get_one(self, id):
        raise NotImplementedError('This method must be implemented')
    
    def _get_all(self):
        raise NotImplementedError('This method must be implemented')
    
    def insert(self, id, data):
        raise NotImplementedError('This method must be implemented')
    
    def update(self, id, data):
        raise NotImplementedError('This method must be implemented')
    
    def delete(self, id):
        raise NotImplementedError('This method must be implemented')
    
    def save(self, id, data):
        raise NotImplementedError('This method must be implemented')
    
    def load(self, id):
        raise NotImplementedError('This method must be implemented')
    
    def erase(self, id):
        raise NotImplementedError('This method must be implemented')