# -*- coding: utf-8 -*- 

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

import sys
import traceback
import exceptions
import urllib
import urllib2

from gluon import *
from gluon.contenttype import contenttype

class HTTPError(exceptions.Exception):
    def __init__(self, msg):
        self.message = str(msg)
        
    def __str__(self):
        return self.message
        
def http(url, method='get', headers={}, data=None):
    req = urllib2.Request(url, headers=headers)
    req.get_method = lambda: method.upper()
    if method.upper() == 'POST' or method.upper() == 'PUT':
        req.add_data(data)
        
    try:
        response = urllib2.urlopen(req)
    except IOError, e:
        if hasattr(e, 'reason'):
            raise HTTPError('Failed to reach a server. Reason: %s' % e.reason)
        elif hasattr(e, 'code'):
            raise HTTPError(e.code)
    else:
        # everything is fine
        return response.read()
 