# -*- coding: utf-8 -*-

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

import inspect
import re

from pyjoles.core.messagebus import IBusListener
import pyjoles.core.services

from inotifierlistener import INotifierListener


class NotifierListener(INotifierListener):
    def __init__(self):
        """
        Connect every method matching :
            def _notify__a__signal__path(self, ...)
        
        To the signal :
            a.signal.path
        """
        for meth in inspect.getmembers(self, inspect.ismethod):
            # If we like magic names
            if re.compile("^_notify__.*").match(meth[0]):
                name = meth[0].partition("__")[2]
                signal = name.replace("__", ".")
                pyjoles.core.services.Notifier.subscribe(meth[1], signal)
        
    
