# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon import current, HTTP

from project import ProjectHandler

def rest_roadmap_get(args):
    service=service_roadmap()     
    return service.select(args)    

class service_roadmap:
    def __init__(self):
        self.max_items = 10
    
    def select(self, data):
        if len(data) == 0:
            raise HTTP(404)
            
        if len(data) != 1:
            raise HTTP(404)
        
        rows = ProjectHandler.get_project_roadmap(data[0])        
        list = []
        if len(rows)>0:
            for row in rows:
                tmp = {}
                tmp['id'] = row.roadmap.identifier
                tmp['name'] = row.roadmap.sumary
                tmp['status'] = row.roadmap.status
                tmp['priority'] = row.roadmap.priority
                tmp['start'] = row.roadmap.init_date
                tmp['end'] = row.roadmap.end_date
                tmp['creator'] = row.roadmap.creator
                tmp['responsible'] = row.roadmap.responsible
                tmp['content'] = row.roadmap.content
                tmp['rest_url'] = "%s/api/roadmap/%s" % (current._config.app_url, 
                                                         row.roadmap.identifier)
                tmp['web_url'] = "%s/roadmap/read/%s" % (current._config.app_url,
                                                         row.roadmap.id)
                
                list.append(tmp)
        return {'json_data':list} 
    