# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon import current

from core.subapplication import SubApp, SubAppModule

from models.type import ProjectTypeModel

class ProjectType(SubAppModule):
    def __init__(self, controller='project'):
        SubAppModule.__init__(self, 'project', 'type')
        
    #@auth.requires_login()
    #@auth.requires_membership('admin')
    def index(self):
#        _menu.controller={'name': T('Project Type'),
#                          'module': 'projecttype',
#                          'function': 'index'}
        current._menu.show()
        insKlss = ProjectTypeModel(current.db) 
        return dict(form=insKlss.grid())
    
    #@auth.requires_login()
    #@auth.requires_membership('admin')
    def configure(self):
        from service import ServiceManager
        from system import AuthConfiguration
    
        id='projecttype'
        smng = ServiceManager("masters")
        auth_mng = AuthConfiguration(current.db)
        data = None
        
        if len(current.request.vars) > 0:
            data = smng.get(id)
            auth_mng.delete(id)
            for action in data['actions']:
                if action['id'] in current.request.vars:
                    auth_mng.add(id, 
                                 action['id'], 
                                 current.request.vars[action['id']])
        
        data = None
        if id in smng.services.keys():
            data = smng.get_as_dict(id, auth_mng) 
        return dict(id=id, data=data)
