# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

import textwrap

from gluon import current

class MyTEXTER:
    def __init__(self,name=None,header=None):
        self.newline = "\n"
        self.indentation = '    '
        self.buffer=''
        self.name=name
        
        if header is not None:
            self.write(header)
        
    def ident(self,txt,ident=1):
        identation=ident*self.indentation
        return "%s%s"%(identation,txt)
        
    def write(self,txt):
        self.buffer+=txt
        self.nl()
        
    def paragraph(self,txt):
        self.buffer+=txt
        self.nl()
        
    def nl(self):
        self.buffer+=self.newline
        
    def line(self,max=70,char='-'):
        line= ''
        for x in range(1, max):
            line = line + char
        self.write(line)
        
    def header(self, title, subtitle):
        if len(title) <= len(subtitle):
            range=len(subtitle)
        else:
            range=len(title)
        self.line(range,'=')
        self.write(title)
        self.write(subtitle)
        self.line(range,'=')
        
    def output(self,dest='P'):
        if dest=='S':
            current.response.headers['Content-Type']='text/txt'
            if self.name is not None:
                current.response.headers['Content-Disposition'] = \
                                "attachment; filename=%s.txt"%self.name;
            
        return self.buffer
    
    def encode(self,str):
        '''
        convert iso-8859-1
        '''
        return str
#        return unicode(str,'utf-8').encode('iso-8859-1') 