# -*- coding: utf-8 -*- 

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from mil.base import File
from mil.system import INotifierListener

# System Listeners
class ErrorToFile(INotifierListener):
    def __init__(self, file_path):
        if not File.exists(file_path):
            File.touch(file_path)
        self.file_path = file_path
            
    def receipt(self, data):
        try:        
            from datetime import datetime
            line = "%s [%s] %s\n" % (datetime.now(), 
                                     data.severity, 
                                     str(data.message))
            File.add(self.file_path, line)
            File.file_version_by_size(self.file_path)
        except Exception, e:
            import pprint; pprint.pprint(e)