# -*- coding: utf-8 -*-
#
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

import urllib2
from python_webdav.client import Client as Client

class WebdavClient(Client):
    def __init__(self, webdav_server_uri, webdav_path='.', port=80, realm=''):
        Client.__init__(self, webdav_server_uri, webdav_path, port, realm)
   
    def get(self,path='',user='',passwd=''):
        try:
            self.set_connection(username=user, password=passwd)
            return self.ls(path,display=False)
        except:
            raise(Exception(T("Data not available")))
    
    def getFile(self,file_path,user='',passwd=''):
        """ Download a file from file_path to dest_path

            :param file_path: Path to the resource to download
            :type file_path: String

            :param dest_path: Path to where the downloaded file should be saved
            :type dest_path: String

        """
        self.set_connection(username=user, password=passwd)
        resource_path = urllib2.urlparse.urljoin(self.connection.path,
                                                 file_path)
        resp, content = self.connection.send_get(resource_path)
        return [resp,content]
        