# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon import current, URL
from gluon.storage import Storage

from iwidget import IWidget

class AdminMenu(IWidget):
    name = 'adminmenu'
        
    def prepare(self):
        # Prepare Menu
        menu = []
        for item in current.response.menu:
            (name, active, link) = item[:3]
            item_data = Storage()
            
            item_data.type = 'element' 
            active_url = URL(current.request.controller, 
                             current.request.function)
            if active_url == link:
                item_data.active = True
            else:
                item_data.active = False
            item_data.href = link
            item_data.label = name
            item_data.submenu = []
            if len(item) > 3 and item[3]:
                item_data.type = 'submenu' 
                for subitem in item[3]:
                    (name, active, link) = subitem[:3]
                    submenu = Storage()
                    submenu.href = link
                    submenu.label = name                    
                    item_data.submenu.append(submenu)

            menu.append(item_data)
        self.attributes['menu'] = menu