# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

class IWidget(object):
    name = 'base'
    def __init__(self, **kwargs):
        self.attributes = {}
        if len(kwargs) > 0:
            for key in kwargs:
                self.attributes[key] = kwargs[key]
                
        self.prepare()
        
    def prepare(self):
        pass
            
    def xml(self):
        return self._render()
    
    def _render(self):
        from gluon import current
        from gluon.template import render
        from gluon.storage import Storage
        import os

        filename = os.sep.join([current.request.folder+"views",
                                '_widgets',
                                "%s.html" % self.name])
        
        if not os.path.exists(filename):
            return ""
                
        # Prepare attributes
        view_data = Storage()
        for item in self.attributes:
            view_data[item] = self.attributes[item]
        try:
            html_data = render(filename=filename, context=view_data)
        except Exception, e:
            html_data = ''
        return html_data
#        return render(filename=filename, context= view_data)
    