# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# This file is based  in a development by Massimo Di Pierro
# It is released under BSD, MIT and GPL2 licenses

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon import *

###################################################
# required parameters set by default if not set
###################################################
if current.request.env.web2py_path:
    DEFAULT = {
        'editor' : current.auth.user and current.auth.has_membership(role='editor') or current.auth.user_id==1, # if current user a editor?
        'mode'   : 'markmin',    # 'markmin' or 'html' for wysiwyg editor
        'level'  : 3,            # 1 - wiki only, 2 - widgets enables, 3 - remplate render enabled
        'migrate': True,         # set to False in production
        'theme'  : 'redmond', # the jquery-ui theme, mapped into wiki/ui/%(theme)s/jquery-ui-1.8.1.custom.css
        'widgets' : 'all',       # list of widgets to be made available
        'authorize_attachments' : False # shoudl attachment be restricted to the page?
        }
    
    def _():
        """
        the mambo jambo here makes sure that 
        PluginManager.wiki.xxx is also exposed as wiki_xxx
        this is to minimize Storage lookup
        """
#        if not 'db' in globals() or not 'auth' in globals():
#            raise HTTP(500,"wiki requires 'db' and 'auth'")
        from gluon.tools import PluginManager
        prefix='wiki_'
        plugins = PluginManager('wiki',**dict(item for item in DEFAULT.items() if not prefix+item[0] in globals()))
        globals().update(dict((prefix+item,plugins.wiki[item]) for item in DEFAULT))
    _()
    
    
    ###################################################
    # js and css modules required by the plugin
    ###################################################
    for _f in ['wiki/ui/css/%s/jquery-ui-1.8.5.custom.css' % wiki_theme,
               'wiki/ui/js/jquery-ui-1.8.5.custom.min.js',
               'wiki/jqgrid/ui.jqgrid.css',
               'wiki/jqgrid/i18n/grid.locale-en.js',              
               'wiki/jqgrid/jquery.jqGrid.min.js',
               'wiki/slideshow/jquery.cycle.min.js',
               'wiki/multiselect/jquery.multiselect.css',
               'wiki/multiselect/jquery.multiselect.js']:          
        current.response.files.append(URL('static',_f))
        
    def wiki_get_editor():
        try:
            if current._user.project.name:
                wiki_editor = current._government.has_permission('wiki', 
                                                                 'wiki_access', 
                                                                 application='project')
#                wiki_editor = current._user.write  
        except:
            if current._user.is_admin:
                wiki_editor = True
            else:
                wiki_editor = False
        return wiki_editor
    
    
  