# -*- coding: utf-8 -*-

# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'LICENSE' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

###############################################################################
# Please try to conform to PEP-8 as much as possible
# http://www.python.org/dev/peps/pep-0008/
###############################################################################

from gluon import *

from wiki.widgets import PluginWiki

class WikiNS(PluginWiki):
    def __init__(self):
        menu_page = None
        code_page = None
        self.extra = self.extra_blocks()
        
    def show(self, ns='forge'):  
        from wiki.models.wiki_page import WikiPageModel        
        wpKlass = WikiPageModel(current.db)
        
        code_page = wpKlass.get_code_page(ns)
        if code_page and \
           current.request.controller=='wiki' and \
           not current.request.function in ('page_edit', 'page_history'):
            try:
                exec(re.sub('\r\n|\n\r|\r','\n', code_page.body.strip()),
                     globals())
            except Exception, e:
                import traceback
                current.response.flash = 'Internal error, please contact the administrator'

        menu_page = wpKlass.get_menu_page(ns)            
        if menu_page:
            import re
            regex = re.compile('(?P<s> *)(?P<t>.+) +(?P<k>\S+)')
            
            item_menu = []
            parents = [(-1,item_menu)]
            for line in menu_page.body.split('\n'):
                match = regex.match(line)
                if not match: continue
                indent=len(match.group('s'))
                title=match.group('t')
                url=match.group('k')
                if url.lower()=='none':
                    url=self.get_wiki_url(current.request.args)
                elif url.startswith('page:'):
                    url=self.get_wiki_url(url[5:])
                else:
                    url=''
                while indent<=parents[-1][0]:
                    parents.pop()
                newtree=[]
                parents[-1][1].append((title,False,url,newtree)) 
                parents.append((indent,newtree))
#            current.response.menu[-1]=(current.response.menu[-1][0],False,URL('wiki','page',args=current.request.args), item_menu)
            
    def embed_page(self, ns, slug):
        from wiki.models.wiki_page import WikiPageModel        
        wpKlass = WikiPageModel(current.db)
        
        page = wpKlass.get_page(ns, slug)   
        if not page: return page
        return XML(PluginWiki.render(page.body))
    
    def get_wiki_url(self, ns, page):
        return URL(r=current.request,f='page',args=[ns, page])
        
