# -*- coding: utf-8 -*-
 
from gluon import current, URL, redirect
from mil.statemachine import SMComponent, SMBooleanSelection, SMPageViewer, \
                             SMDataStructure, SMCallPage, SMEndNode
            

class IsUserLoggedIn(SMBooleanSelection):    
    def _control(self):
        if current.auth.user is None:
            self.status = False
        else:
            self.status = True
            
class IsLoginProcessActive(SMBooleanSelection):    
    def _control(self):
        if current.request.controller == 'default' and \
           current.request.function == 'user' and \
           current.request.args[0] == 'login':
            self.status = True
        else:
            self.status = False
    
class LoginPage(SMCallPage):  
    def _control(self):
        self.url = URL(r=current.request, c='default', f='user', args='login')
    
class IndexPage(SMPageViewer):   
    pass
    
class IsPrivateForge(SMBooleanSelection):    
    def _control(self):
        if current._config.get('forge_private'):
            self.status = True
        else:
            self.status = False
    
class SelectedOrDashboardPage(SMPageViewer):
    pass
            
    
class EndNode(SMEndNode):  
    pass
            