# coding: utf8
# Este fichero forma parte de openMyWork
#
# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'licence' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

"""
# APACHE CONFIG
# Work around authz and SVNListParentPath issue
RedirectMatch ^(/svntest)$ $1/
 
# Enable Subversion logging
#CustomLog logs/svn_logfile "%t %u %{SVN-ACTION}e" env=SVN-ACTION

# leave with the trailing bar
<Location /svn/>
  # Enable Subversion
  DAV svn
 
  # Directory containing all repository for this path
  SVNParentPath /path/to/svn
 
  # Enable repository listing when browing the Location root
  SVNListParentPath On

    AuthType Basic
    AuthName "User required"
    AuthBasicProvider wsgi
    WSGIAuthUserScript /path/to/application/scripts/dav_svn_wsgi.py
    WSGIAuthGroupScript /path/to/application/scripts/dav_svn_wsgi.py
    #Deactivated because it does not support user autzh
    #WSGIAccessScript /path/to/application/scripts/dav_svn_wsgi.py
    Require group access

    Require valid-user
</Location>


Alias /dav /path/to/dav

<Location /dav>
  DAV On
  AuthType Basic
  AuthName "webdav"
  Options Indexes 
  AuthUserFile /dev/null 
  AuthBasicProvider wsgi
  
  WSGIAuthUserScript /path/to/application/scripts/dav_svn_wsgi.py
  WSGIAuthGroupScript /path/to/application/scripts/dav_svn_wsgi.py
  
  # Deactivated because it does not support user autzh
  #WSGIAccessScript /path/to/application/scripts/dav_svn_wsgi.py
  
  Require group access
  Require valid-user
  
</Location>
"""

"""
DAV / SVN read/write methods
Source: http://svn.apache.org/repos/asf/subversion/trunk/notes/http-and-webdav/webdav-protocol
Read Commands  :  (OPTIONS, PROPFIND, GET, REPORT)

Write Commands  :  (MKACTIVITY, PROPPATCH, PUT, CHECKOUT, MKCOL, MOVE,
                    COPY, DELETE, LOCK, UNLOCK, MERGE)

"""

import sys, os

#set the pythonpath for gluon and app modules

#get current folder
curr_file_path = os.path.dirname(sys.argv[0])

#get the gluon path for extending the pythonpath
gluon_path = os.path.join(curr_file_path,"..","..", "..", "gluon")

#get the modules path for extending the pythonpath
modules_path = os.path.join(curr_file_path,"..","modules")

#extend the pythonpath with gluon and modules path
sys.path.append(gluon_path)
sys.path.append(modules_path)



#WSGI mandatory functions
#Authentication: only check if the user exists
def check_password(environ, user, password):
    if user == 'user':
        if password == 'user':
            return True
        return False
    return None

"""
#No sirve :(
#Authorization: only check if the user has acces to the resource.
def allow_access(environ, host):
    
    if environ['REQUEST_URI'] == '/davtest/proyecto1/':
        return True
    else:
        return False
"""

def groups_for_user(environ, user):
    if user == 'user':
        # ojo a devolver 'access' ya que en la config de apache esta
        # asi
        return ['access']
    return ['']
