# coding: utf8

# Este fichero forma parte de openMyWork
#
# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'licence' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# From web2py directory, console mode, write...
# $ ./web2py.py -S forge -M -R applications/forge/scripts/prepare_database.py -A forge


import os
import sys

from gluon.storage import Storage

## current directory 
CUR_PATH = os.getcwd()

DATA = [{'name': 'new_project',
         'description': 'Create a new Project into forge',
         'content': '''{"node_1":{"label":"Has Permission","type":"boolean","param":"action: _government.has_permission()","pos":{"top":234,"left":285},"connector":{"input":{"con_in1":{"label":"in","connection":""}},"output":{"con_outt":{"label":"true","connection":"node_2.con_in1"},"con_outf":{"label":"false","connection":"node_3.con_in1"}}}},"node_2":{"label":"Card","type":"connector","param":"url: project, card, create","pos":{"top":197,"left":469},"connector":{"input":{"con_in1":{"label":"in","connection":"node_1.con_outt"}},"output":{"con_out1":{"label":"out","connection":"node_4.con_in1"}}}},"node_3":{"label":"Dashboard","type":"end","param":"url: dashboard","pos":{"top":285,"left":467},"connector":{"input":{"con_in1":{"label":"in","connection":"node_1.con_outf"}},"output":{}}},"node_4":{"label":"Leader","type":"connector","param":"url: project,team,leader","pos":{"top":198,"left":583},"connector":{"input":{"con_in1":{"label":"in","connection":"node_2.con_out1"}},"output":{"con_out1":{"label":"out","connection":"node_5.con_in1"}}}},"node_5":{"label":"Service","type":"connector","param":"url: project,service","pos":{"top":197,"left":714},"connector":{"input":{"con_in1":{"label":"in","connection":"node_4.con_out1"}},"output":{"con_out1":{"label":"out","connection":"node_9.con_in1"}}}},"node_9":{"label":"End","type":"end","param":"url: dashboard","pos":{"top":197,"left":833},"connector":{"input":{"con_in1":{"label":"in","connection":"node_5.con_out1"}},"output":{}}}}'''}, 
        {'name': 'login',
         'description': 'Forge login process',
         'content': '''{"node_1":{"label":"Is User Logged in","type":"boolean","param":"action: auth.user, is, None","pos":{"top":195,"left":285},"connector":{"input":{"con_in1":{"label":"in","connection":""}},"output":{"con_outt":{"label":"true","connection":"node_3.con_in1"},"con_outf":{"label":"false","connection":"node_2.con_in1"}}}},"node_2":{"label":"Selected or Dashboard Page","type":"end","param":"","pos":{"top":142,"left":467},"connector":{"input":{"con_in1":{"label":"in","connection":"node_1.con_outt"}},"output":{}}},"node_3":{"label":"Is Login proccess active","type":"boolean","param":"cond: {request.controller, eq, 'default'} and {request.function, eq, 'user'} and {request.args[0], eq, 'login'}","pos":{"top":243,"left":472},"connector":{"input":{"con_in1":{"label":"in","connection":"node_1.con_outf"}},"output":{"con_outt":{"label":"true","connection":"node_4.con_in1"},"con_outf":{"label":"false","connection":"node_5.con_in1"}}}},"node_4":{"label":"End","type":"end","param":"","pos":{"top":209,"left":701},"connector":{"input":{"con_in1":{"label":"in","connection":"node_3.con_outt"}},"output":{}}},"node_5":{"label":"is Private Forge","type":"boolean","param":"action: _config.get('forge_private')","pos":{"top":289,"left":699},"connector":{"input":{"con_in1":{"label":"in","connection":"node_3.con_outf"}},"output":{"con_outt":{"label":"true","connection":"node_6.con_in1"},"con_outf":{"label":"false","connection":"node_7.con_in1"}}}},"node_6":{"label":"Login","type":"end","param":"url: default, user, login","pos":{"top":265,"left":878},"connector":{"input":{"con_in1":{"label":"in","connection":"node_5.con_outt"}},"output":{}}},"node_7":{"label":"Index","type":"end","param":"url: default","pos":{"top":343,"left":876},"connector":{"input":{"con_in1":{"label":"in","connection":"node_5.con_outf"}},"output":{}}}}'''}
        ]
                
def launch(*args):
    # Parameters
    param=Storage()
    args_name=['app']
    for i in range(len(args)):
        try:
            param[args_name[i]]=args[i]
        except:     # No se tiene en cuenta el parametro
            pass
    
    try:
        # Import model
        from masters.workflows import WorkFlows
        insKlass = WorkFlows(db)
        
        for item in DATA:
            insKlass.insert(item['name'], item['description'], item['content'])
    except Exception, e:
        print"Error: '%s'" % str(e) 
        
    print 'Done'
            
args=sys.argv[1:] 
launch(*args) 