#!/usr/bin/python
# vim: set fileencoding=UTF8 :

# Copyright (C) 2008 Jon Latorre Martinez <moebius@grupoikusnet.com>
# Copyright (C) 2012 Jesus Martinez <jamarcer@gmail.com>

#svnlog.conf
#[database]
#host=localhost
#dbname=svnlog
#user=svnlog
#passwd=svnlog
#table=svnlog

import os
import MySQLdb
import sys
import ConfigParser
from optparse import OptionParser

class svnlook:
    def __init__(self, configfile, repo, commit):
        #Cogemos el ultimo directorio como nombre del repo
        self.repo=repo.split('/')[-1]
        #Guardamos el numero de commit
        self.commit=commit
        #Guardamos el path del repo
        self.path=repo
        #Cargamos la conf:
        config = ConfigParser.ConfigParser()
        config.read(configfile)
        self.user = config.get('database','user')
        self.passwd = config.get('database','passwd')
        self.host = config.get('database','host')
        self.dbname = config.get('database','dbname')
        self.tablename = config.get('database','table')
        #Nos conectamos a MySQL
        self.db=MySQLdb.connect(host=self.host,user=self.user,passwd=self.passwd,db=self.dbname)
        self.cursor=self.db.cursor()
    def insertar(self):
        sql="INSERT INTO %s (repo,commit,fecha,autor,comentario) VALUES ('%s','%s',NOW(),'%s','%s');"%(self.tablename,self.repo,self.commit,self.autor(),self.comentario())
        #print "Vamos a lanzar el SQL: %s"%sql
        self.cursor.execute(sql)
        self.cursor.close()
        self.db.close()
    def __comando(self, comando):
        """Funcion interna que lanza un comando de sistema (svnlook normalmente) con popen y devuelve su salida estandar"""
        proceso=os.popen(comando)
        salida=proceso.read()
        salida=salida.rstrip()
        return salida

    def info(self):
        #print "Sacando la info de: ",self.repo 
        #print "Que esta en: ",self.path
        proceso=os.popen('svnlook info '+self.path)
        salida=proceso.read()
        salida=salida.rstrip()
        return salida
    def autor(self):
        proceso=os.popen('svnlook author -r %s %s'%(self.commit,self.path))
        salida=proceso.read()
        salida=salida.rstrip()
        return salida
    def comentario(self):
        ret=self.__comando('svnlook log -r %s %s'%(self.commit,self.path))
        return ret



if __name__=='__main__':
    if len(sys.argv) < 3:
        print "Faltan parametros"
        sys.exit(-1)
    #Vamos a parsear en busca de configfile
    parser = OptionParser()
    parser.add_option("-c", "--config",action="store", type="string", dest="configfile")
    (options, args) = parser.parse_args()
    if not options.configfile:
        print "Falta indicar el fichero de configuración"
        exit()
    if len(args) != 2:
        print "Faltan parametros"
        exit()

    svn=svnlook(options.configfile,args[0],args[1])
    #print svn.info()
    #print svn.autor()
    #print svn.comentario()
    svn.insertar()


