# coding: utf8
# Este fichero forma parte de openMyWork
#
# Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
# Copyright Jesus Martinez      <jamarcer@gmail.com>
#
# Este fichero se distribuye bajo la licencia GPL según las
# condiciones que figuran en el fichero 'licence' que se acompaña.
# Si se distribuyera este fichero individualmente, DEBE incluirse aquí
# las condiciones expresadas allí.
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# From web2py directory, console mode, write...
# $ ./web2py.py -S forge -M -R applications/forge/scripts/test_sm.py

from gluon.storage import Storage
from mil.tools import get_ts, format_ts, nearest, get_datetime_from_string, inside

def get_nearest_lit(date, min_datets, max_datets, format_out = "%d-%m-%Y"):
    range_near = nearest(date, min_datets, max_datets)
    if range_near == -1:
        literal = 'Previous'
    elif range_near == 1:
        literal = 'Passed'
    else:
        literal = 'Inside'
    return "%s %s %s %s" % (min_datets.strftime(format_out), 
                            date.strftime(format_out), 
                            max_datets.strftime(format_out), 
                            literal)
    
def get_inside_lit(date, min_datets, max_datets, format_out = "%d-%m-%Y"):
    range_near = inside(date, min_datets, max_datets)
    if range_near:
        literal = 'Inside'
    else:
        literal = 'Out'
    return "%s %s %s %s" % (min_datets.strftime(format_out), 
                            date.strftime(format_out), 
                            max_datets.strftime(format_out), 
                            literal)

def functionality(): 
    format_in = "%Y-%m-%d"
    format_out = "%d-%m-%Y"
    
    min_datets = get_datetime_from_string('2012-06-01', format_in)
    max_datets = get_datetime_from_string('2012-07-01', format_in)
    
    previous_ts = get_datetime_from_string('2012-05-01', format_in)
    inside_ts = get_datetime_from_string('2012-06-15', format_in)
    passed_ts = get_datetime_from_string('2012-08-01', format_in)
    
    print "TimeStamp test \n"
    print get_nearest_lit(format_ts(), min_datets, max_datets, format_out)
    print get_nearest_lit(previous_ts, min_datets, max_datets, format_out)
    print get_nearest_lit(inside_ts, min_datets, max_datets, format_out)                        
    print get_nearest_lit(passed_ts, min_datets, max_datets, format_out)
    
    print "Inside test"
    
    print get_inside_lit(format_ts(), min_datets, max_datets, format_out)
    print get_inside_lit(previous_ts, min_datets, max_datets, format_out)
    print get_inside_lit(inside_ts, min_datets, max_datets, format_out)
    print get_inside_lit(passed_ts, min_datets, max_datets, format_out)
    print "\ndone"
    
def launch(*args):
    # Parametros
    param=Storage()
    args_name=[]
    for i in range(len(args)):
        try:
            param[args_name[i]]=args[i]
        except:     # No se tiene en cuenta el parametro
            pass
        
    functionality()

try:
    args=sys.argv[1:] 
except:
    args=[]
launch(*args) 
