# coding: utf8

from gluon.storage import Storage
# coding: utf8

# From web2py directory, console mode, write...
# $ ./web2py.py -S <app> -M -R applications/<app>/scripts/upgrade/None_1.0.0/upgrade_01.py
# $ ./web2py.py -S forge -M -R applications/forge/scripts/upgrade/None_1.0.0/upgrade_01.py

import os
import sys
import re

from gluon.storage import Storage

from mil.base import YAMLFile
    
class ConfigPyFile:
    @staticmethod     
    def get_items(config_name):
        data={}
        if os.path.isfile(config_name):
            # Read file    
            fh = open(config_name, "r")
            for line in fh.readlines():
                line = line.strip(' \t\n\r')                
                if len(line) == 0:        # discard empty lines
                    continue                
                elif line[0] == '#':    # discard commented lines
                    continue                
                else:                   # process line
                    param = line.split('=')
                    name = param[0].strip()
                    value = param[1].strip()
                    # clean extra characters
                    if value[0] == '[':
                        value = value[1:-1]
                    
                    if value[0] == '\'':
                        value = value[1:-1]
                    data[name.lower()] = value
            fh.close()
    
        return data

def prepare_system(path_15):
    if os.path.exists(path_15):
        tmp = Storage()
        
        # Get 1.5 configuration: path = models/config.py
        config_path = os.path.join(path_15, 'models', 'config.py')
        
        # Load config.py data into configuration system
        # Detect and load config.py
        if os.path.exists(config_path):
            config_15 = ConfigPyFile.get_items(config_path)
        else:
            return None
        # Prepare parameters
        tmp.admin = config_15['admin_email']
        tmp.dal = config_15['db_dal']
        tmp.webdav_path = config_15['webdav_server']
        tmp.svn_path = config_15['svn_server']
        tmp.installation_type = config_15['installation_type']
        if config_15['force_guestbook'] == 'True':
            tmp.guestbook = True
        else:            
            tmp.guestbook = False
        # file path uploads/
        tmp.uploads = os.path.join(path_15, 'uploads')
                
        # Return migrate configuration        
        return tmp
    else:
        None