# coding: utf8

from gluon import *
from gluon.utils import web2py_uuid

def migrate_users(db_orig, admin_email):
    user_list = {}
    rows = db_orig(db_orig.user.id > 0).select()
    current_ident = None   
    for row in rows:
        if row.email != admin_email:
            [first, last] = row.name.split(' ', 1);                
            tmp = {'identifier': web2py_uuid(),
                   'first_name': first,
                   'last_name': last,
                   'email': row.email,
                   'password': row.password,
                   'is_admin': row.is_admin,
                   'preferences': row.preferences or ''}

            # Add user in modules/master/user.py
            from masters.users import Users
            users = Users(current._config, current.db) 
            # Check if user exists
            user = users.get(tmp['email'])
            if user is None:
                id = users.add_forced(tmp['identifier'], 
                                      tmp['first_name'], 
                                      tmp['last_name'], 
                                      tmp['email'], 
                                      tmp['password'])
                # If has preferences
                if tmp['preferences'] != '':
                    query = (current.db.auth_user.id==id)
                    current.db(query).update(preferences=tmp['preferences'])
                # I user is admin
                if tmp['is_admin']:
                    current.auth.add_membership('admin', id)
            else:
                id = user['id']
                
            # Add user to list
            user_list[row.id] = id
            
    return user_list