# coding: utf8

from gluon import *

from wiki.models.wiki_attachment import WikiAttachmentModel
from wiki.models.wiki_comment import WikiCommentModel
from wiki.models.wiki_link import WikiLinkModel
from wiki.models.wiki_page_archive import WikiPageArchiveModel
from wiki.models.wiki_page import WikiPageModel 
from wiki.models.wiki_tag import WikiTagModel
    
def migrate_wiki(db_orig):    
    ret_val = []
    # Prepare models   
    WikiAttachmentModel.define_table(current.db)
    WikiCommentModel.define_table(current.db)
    WikiLinkModel.define_table(current.db)
    WikiPageArchiveModel.define_table(current.db)
    WikiPageModel.define_table(current.db)
    WikiTagModel.define_table(current.db)
     
    # Migrate wiki    
    entities = ['wiki_page', 'wiki_page_archive', 'wiki_attachment', 'wiki_comment', 'wiki_tag', 'wiki_link' ]
    for entity in entities:
        rows = db_orig(db_orig[entity].id > 0).select()        
        for row in rows:
            tmp = {}
            for item in row.keys():
                if not item in ['id', 'update_record', 'delete_record', 'wiki_page_archive']:
                    tmp[item] = row[item]
            current.db[entity].insert(**tmp)