# coding: utf8

# From web2py directory, console mode, write...
# $ ./web2py.py -S <app> -M -R applications/<app>/scripts/upgrade/1.5_2.0/upgrade_01.py
# $ ./web2py.py -S forge -M -R applications/forge/scripts/upgrade/1.5_2.0/upgrade_01.py

import os
import sys
import inspect

extra_path = os.path.abspath(os.path.dirname(inspect.getfile(inspect.currentframe())))
sys.path.append(extra_path) 

modules_path = os.path.abspath('applications/forge/modules/')
sys.path.append(modules_path) 

from gluon import DAL

from mil.base import File

from extra.database_15 import populate_database
from extra.users import migrate_users
from extra.system import prepare_system
from extra.projects import migrate_projects
from extra.wiki import migrate_wiki

def launcher(*args):  
    # Old db connection
    path_orig = os.path.join(w2p_path, 'applications', 'forge_15')
    
    # System 1.5 to 2.0
    migrate_config = prepare_system(path_orig)
    if migrate_config is None:
        print "Application not exists. Can't migrate it"
        exit()
    
    # DAL connection
    dal_orig = migrate_config.dal
    db_orig = DAL(dal_orig, migrate=False)
    populate_database(db_orig)
    
    # Old db connection
    dal_dest = _config.get('dal')
    db_dest = DAL(dal_dest, migrate=True)    
    
    # Migrate users
    users = migrate_users(db_orig, migrate_config.admin_email)
    
    # Migrate projects
    migrate_projects(db_orig, users) 
    
    # Migrate files from file entity
    origin = os.path.join(path_orig, 'uploads')
    destiny = os.path.join(app_path, 'uploads')
    File.remove_dir(destiny)
    File.copy_dir(origin, destiny)

    # Migrate wiki    
    migrate_wiki(db_orig)
    
    print 'Done'

args=sys.argv[1:]       
launcher(*args)