/*
* Este fichero forma parte de openMyWork
*
* Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
* Copyright Jesus Martinez      <jamarcer@gmail.com>
*
* Este fichero se distribuye bajo la licencia GPL según las
* condiciones que figuran en el fichero 'licence' que se acompaña.
* Si se distribuyera este fichero individualmente, DEBE incluirse aquí
* las condiciones expresadas allí.
*
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

//    call: function(url_params,div_id,url_args){
//		if (url_args === undefined) {
//			url_args = [];
//		}

//add "endsWith" Functionality
String.prototype.endsWith = function(str) 
{return (this.match(str+"$")==str)}

function inspect(obj, maxLevels, level)
{
  var str = '', type, msg;

    // Start Input Validations
    // Don't touch, we start iterating at level zero
    if(level == null)  level = 0;

    // At least you want to show the first level
    if(maxLevels == null) maxLevels = 1;
    if(maxLevels < 1)     
        return '<font color="red">Error: Levels number must be > 0</font>';

    // We start with a non null object
    if(obj == null)
    return '<font color="red">Error: Object <b>NULL</b></font>';
    // End Input Validations

    // Each Iteration must be indented
    str += '<ul>';

    // Start iterations for all objects in obj
    for(property in obj)
    {
      try
      {
          // Show "property" and "type property"
          type =  typeof(obj[property]);
          str += '<li>(' + type + ') ' + property + 
                 ( (obj[property]==null)?(': <b>null</b>'):('')) + '</li>';

          // We keep iterating if this property is an Object, non null
          // and we are inside the required number of levels
          if((type == 'object') && (obj[property] != null) && (level+1 < maxLevels))
          str += inspect(obj[property], maxLevels, level+1);
      }
      catch(err)
      {
        // Is there some properties in obj we can't access? Print it red.
        if(typeof(err) == 'string') msg = err;
        else if(err.message)        msg = err.message;
        else if(err.description)    msg = err.description;
        else                        msg = 'Unknown';

        str += '<li><font color="red">(Error) ' + property + ': ' + msg +'</font></li>';
      }
    }

      // Close indent
      str += '</ul>';

    return str;
}

var OrderedListHandler = {
		DEBUG: false,
		HOVERDEBUG: false,
		
		//config vars
		make_sortable: true,
		make_readonly: false,
		refresh_function: '',
		
		
		// literals
 		literals: { //default values,
				askDeleteItem: "Are you sure to delete this item?",
				askDeleteTag: "Are you sure to delete this tag?",
				askChangePriority: "Are you sure to change the priority?",
				askDeleteDocument: "Are you sure to delete this document?",
 		 		txtCritical: "Critical", 
 		 		txtVeryHigh: "Very High",
 		 		expand: '<i class="icon-chevron-down"></i> expand',
 		 		collapse: '<i class="icon-chevron-up"></i> collapse'
 		 		},
 		 		
		init: function(refresh_name){
 		 	// refresh function
 		 	if (refresh_name === undefined) {
 		 		this.refresh_function='';
 		 	} else {
 		 		this.refresh_function=refresh_name; 		 		
 		 	}		
	
			//make sortable
			if (OrderedListHandler.make_sortable == true){
				jQuery(".ui-sortable").sortable({update: this.sortUpdate,  placeholder: 'ol-item-placeholder', forcePlaceholderSize:true });
				//jQuery(".ui-sortable").sortable({update: this.sortUpdate, connectWith: ".ui-sortable", placeholder: 'ol-item-placeholder', forcePlaceholderSize:true });
				//to activate sortable and drag 'n drop use this: connectWith: ".ui-sortable",
			}
			
			//make readonly
			if(OrderedListHandler.make_readonly == true){
				if (!jQuery(".ol-subitem-add-btn, .ol-item-delete-btn, .ol-item-edit-btn, .ol-item-add-tag, .ol-item-change-description, .ol-item-add-comment, .ol-a-add-btn, .ol-item-add-doc").hasClass("ol-invisible")){
					jQuery(".ol-subitem-add-btn, .ol-item-delete-btn, .ol-item-edit-btn, .ol-item-add-tag, .ol-item-change-description, .ol-item-add-comment, .ol-a-add-btn, .ol-item-add-doc").addClass("ol-invisible");
				}
				jQuery('.ol-item-tag-delete, .ol-item-document-delete').remove();
				/*
				 * <td class="ol-subitem-add-btn"></td>
						<td class="ol-item-delete-btn"></td>
						<td class="ol-item-edit-btn"></td>
						ol-item-add-tag
						ol-item-change-description
						ol-item-add-comment
				 * */
			}
			
			//jQuery("#sortable").sortable({stop: this.sortUpdate });
			jQuery(".ol-queue-container").bind("click", this.menuItemClick);
			
			//** PRIORITY Bindings**//
			if(OrderedListHandler.make_readonly == false){
				//jQuery(".ol-item-priority").click(this.changePriorityClick);
			}
						
			//** ADD TO Bindings **//
			jQuery(".ol-item-add").bind("click", this.addItemClick); //add
			
			//** CHANGE Bindings **//
			//jQuery(".ol-item-change-priority").bind("click", this.changePriorityClick); //change priority
			
			jQuery(".ol-priority-state").live({
											mouseenter:this.priorityStateEnter,
											click: this.priorityStateClick});
			jQuery(".ol-priority-menu").live({mouseleave:this.priorityStateLeave});
			//** ASSING TO Bindings **//
			jQuery(".ol-a-add-btn").bind("click", this.assignToClick); //add assign
			
			//** COMMENTS Bindings **//
			jQuery(".ol-item-add-comment").bind("click", this.addCommentClick); //add assign
			
			//** TAGS Bindings **//
			jQuery(".ol-item-add-tag").bind("click", this.addTagClick); //add tag click
			jQuery(".ol-item-tag-content").bind("click", this.tagClick); //simple tag click
			jQuery(".ol-item-tag-delete").bind("click", this.deleteTagClick); //delete tag click
			jQuery(".ol-item-tag").hover(this.tagWholeDIVHoverIn, this.tagWholeDIVHoverOut);
			jQuery(".ol-item-tag-delete").hover(this.deleteTagItemHoverIn, this.deleteTagItemHoverOut);
			jQuery(".ol-item-tag-content").hover(this.tagItemHoverIn, this.tagItemHoverOut);
			
			
			
			//** DOCUMENTS Bindings **//
			jQuery(".ol-item-add-doc").bind("click", this.addDocClick); //add assign
			jQuery(".ol-item-document-content").bind("click", this.documentClick); //simple tag click
			jQuery(".ol-item-document-delete").bind("click", this.deleteDocumentClick); //delete tag click
			jQuery(".ol-item-document").hover(this.documentWholeDIVHoverIn, this.documentWholeDIVHoverOut);
			jQuery(".ol-item-document-delete").hover(this.deleteDocumentItemHoverIn, this.deleteDocumentItemHoverOut);
			jQuery(".ol-item-document-content").hover(this.documentItemHoverIn, this.documentItemHoverOut);
			
			//** MENU Bindings**//
			jQuery(".ol-queue-container").hover(this.menuItemHoverIn, this.menuItemHoverOut);
			
			//** ITEM BLOCK Bindings**//
			jQuery(".ol-content-item").hover(this.contentItemHoverIn, this.contentItemHoverOut);
			
			//** TABS Bindings**//
			jQuery(".ol-list-state-tabs").bind("click", this.listStateClick); //delete tag click
			
			//** BUTTONS Bindings**//
			jQuery(".ol-list-show-all-btn").bind("click", this.Util.toggleAll);
			jQuery(".ol-item-show-all-btn").bind("click", this.Util.toggleAllRow);
			if(OrderedListHandler.make_readonly == false){
				jQuery(".ol-item-mark-btn").bind("click", this.itemCheckedClick);
			}
			jQuery(".ol-item-responsible-btn").bind("click", this.Util.toggleResponsibleRow);			
			jQuery(".ol-item-description-btn").bind("click", this.Util.toggleDescriptionRow);
			jQuery(".ol-item-tags-btn").bind("click", this.Util.toggleTagsRow);
			jQuery(".ol-item-documents-btn").bind("click", this.Util.toggleDocumentsRow);
			jQuery(".ol-item-comments-btn").bind("click", this.Util.toggleCommentsRow);
			jQuery(".ol-subitem-add-btn").bind("click", this.addSubitemClick);
			jQuery(".ol-item-delete-btn").bind("click", this.deleteItemClick);
			jQuery(".ol-item-edit-btn").bind("click", this.editItemClick);
			
			//** DESCRIPTION Bindings**//
			jQuery(".ol-item-expand-description").bind("click", this.itemExpandDescription);
			jQuery(".ol-item-change-description").bind("click", this.itemChangeDescription);
			
			//** DATE Bindings**//
			jQuery(".ol-item-add-date").live("click", this.addDateClick);
			
			
			
			jQuery("#olContentList .ol-item-list-controls").mouseover(function (event) {
				 	//jQuery("#object_inspect").html(event.target.className);
		            var target = $(event.target);

		            if (target) {
		                if (target.hasClass("ol-item-mark-btn") || target.hasClass("ol-item-show-all-btn") || target.hasClass("ol-item-responsible-btn") || target.hasClass("ol-item-description-btn") || target.hasClass("ol-item-tags-btn") || target.hasClass("ol-item-comments-btn") || target.hasClass("ol-item-documents-btn") || target.hasClass("ol-subitem-add-btn") || target.hasClass("ol-item-delete-btn") || target.hasClass("ol-item-edit-btn")) {
		                	
		                    target.addClass("ol-item-btn-hover")
		                } else {
		                    if (target.hasClass("gq-a-comment-edit")) {
		                        target.addClass("gq-a-comment-hover")
		                    }
		                }
		            }
		        });
		     $("#olContentList .ol-item-list-controls").mouseout(function (event) {
		            var target = $(event.target);
		            if (target) {
		            	if (target.hasClass("ol-item-mark-btn") ||target.hasClass("ol-item-show-all-btn") || target.hasClass("ol-item-responsible-btn") || target.hasClass("ol-item-description-btn") || target.hasClass("ol-item-tags-btn") || target.hasClass("ol-item-comments-btn") || target.hasClass("ol-item-documents-btn") || target.hasClass("ol-subitem-add-btn") || target.hasClass("ol-item-delete-btn") || target.hasClass("ol-item-edit-btn")) {
		                    target.removeClass("ol-item-btn-hover")
		                } else {
		                    if (target.hasClass("gq-a-comment-edit")) {
		                        target.removeClass("gq-a-comment-hover")
		                    }
		                }
		            }
		        });
				
				OrderedListHandler.configure();

		},
		priorityStateClick: function(){
			var main_row_id = ($(this).closest(".ol-item-row").attr("id"));
			var priority_level = $(this).attr("priority-level");
			OrderedListHandler.priorityChanged(main_row_id, priority_level);
		},
		priorityStateEnter: function(){
			var priority=new Array();
		    priority[1]='27';
		    priority[2]='29';
		    priority[3]='7';
		    priority[4]='3';
		    priority[5]='5';
		    priority[6]='13';
		    
		    var priority_level = $(this).attr("priority-level");		    
			var config = eval('('+$(this).closest(".ol-item-row").attr("config")+')');
			for (var p in priority){
				console.log(p);
				$(this).closest(".ol-item-row").removeClass("ol-queue-bkgnd-"+priority[p]);
		    }			
			$(this).closest(".ol-item-row").addClass("ol-queue-bkgnd-"+priority[priority_level]);
		},
		priorityStateLeave: function(){
			console.log($(this).attr("priority-level")+" leave");
			var priority=new Array();
		    priority[1]='27';
		    priority[2]='29';
		    priority[3]='7';
		    priority[4]='3';
		    priority[5]='5';
		    priority[6]='13';
		    
		    var priority_level = $(this).attr("priority-level");		    
		    var config = eval('('+$(this).closest(".ol-item-row").attr("config")+')');
		    for (var p in priority){
				$(this).closest(".ol-item-row").removeClass("ol-queue-bkgnd-"+priority[p]);
		    }	
			$(this).closest(".ol-item-row").addClass("ol-queue-bkgnd-"+priority[config.priority]);
		},
		refresh_menu: function () {
			if(typeof this.refresh_function == 'function') {
				this.refresh_function();		 			
		 	}
		},
		
		disableSortable: function (){
			jQuery(".ui-sortable").sortable( "disable" );
			OrderedListHandler.make_sortable = false;
		},
		enableSortable: function (){
			jQuery(".ui-sortable").sortable( "enable" );
			OrderedListHandler.make_sortable = true;
			jQuery(".ui-sortable").sortable({update: OrderedListHandler.sortUpdate });
		},
		itemCheckedClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Check Click");
			}
			main_row = OrderedListHandler.Util.getMainRow(event.target)
			config = OrderedListHandler.Util.getConfig(main_row);
			OrderedListHandler.Util.call([config.callback,config.close_item,config.pname,config.id,config.tid],'flash');
			jQuery('#item_'+config.tid).remove();
			jQuery('#flash').show();
			OrderedListHandler.refresh_menu();
		},		
		configure: function(){			
			//configure each row.
			jQuery(".ol-item-row").each(function(index){
				OrderedListHandler.configureRow(index, this);
			});
		},
		configureRow: function(index, row){
			//set colspan and rowspan
			OrderedListHandler.configureColSpanRowSpan(row);
			
			if (jQuery(row).hasClass("ol-hidden")){
				return;
			} else {
				jQuery(row).find(".ol-item-responsible-row:first,.ol-item-description-row:first,.ol-item-tags-row:first,.ol-item-comments-row:first,.ol-item-documents-row:first").toggleClass("ol-hidden",true);
			}
			
			config = OrderedListHandler.Util.getConfig(row);
			
			
			
			//set priority and colour
			OrderedListHandler.configurePriorityRow(row.id,config.priority);
			
			//check description
			OrderedListHandler.configureDescriptionRow(row);
			
			//check responsible
			OrderedListHandler.configureResponsibleRow(row);
			//check tags
			OrderedListHandler.configureTagsRow(row);
			//check comments
			OrderedListHandler.configureCommentsRow(row);
			//check documents
			OrderedListHandler.configureDocumentsRow(row);
		},
		configureColSpanRowSpan: function(row){
			var rowCount = jQuery(row).find("table:first tr").length;
			var colCount = jQuery(row).find("table:first tr:first td").length;
			//set rowspan
			jQuery(row).find("table:first tr:first .ol-item-spacer").attr('rowspan',rowCount);
			jQuery(row).find("table:first tr:first .ol-item-order").attr('rowspan',rowCount);
			jQuery(row).find("table:first tr:first .ol-item-spacer-10").attr('rowspan',rowCount);

			//set colspan
			jQuery(row).find("table:first tr:gt(0)").each(function(){
				jQuery(this).find("td:last").attr('colspan', colCount - 3)//4 because of the 3 rowspan and the space of the td with the mark button
			});

		},
		configurePriorityRow: function(id, priority){
			OrderedListHandler.Util.change_priority(id, 1, priority);
		},		
		configureDescriptionRow: function(row){
			drow = jQuery(row).find(".ol-item-description");			
			if (drow.html()!= null) {
				if(drow.html().length > 0){				
					//add attrib			
					jQuery(row).find(".ol-content-item:first").attr("hasdescription",true);				
				}
			}
		},
		configureResponsibleRow: function(row){
			try {
				arow = jQuery(row).find(".ol-item-responsible:first");				
				if (arow.html()!= null) {
					if(arow.html().length > 0){
						jQuery(row).find(".ol-content-item:first").attr("hasresponsible",true);
					}
				}
			} catch(err){
				if (OrderedListHandler.DEBUG == true){
					txt="Error: " + err.description + "\n\n";
				    txt+="Click OK to continue.\n\n";
				    console.log(txt);
				}
			}
		},
		configureTagsRow: function(row){
			trow = jQuery(row).find(".ol-item-tag:first");		
			if (trow.html()!= null) {
				if(trow.html() != null){
					jQuery(row).find(".ol-content-item:first").attr("hastags",true);
				}
			}
		},
		configureCommentsRow: function(row){
			crow = jQuery(row).find(".ol-item-comments_area:first").find(".ol-item-comment:first");	
			if (crow.html()!= null) {
				if(crow.html() != null){
					jQuery(row).find(".ol-content-item:first").attr("hascomments",true);
				}
			}
		},		
		configureDocumentsRow: function(row){
			drow = jQuery(row).find(".ol-item-documents_area:first").find(".ol-item-document:first");
			
			if (drow.html()!= null) {
				if(drow.html() != null){
					jQuery(row).find(".ol-content-item:first").attr("hasdocuments",true);
				}
			}
			//set mimetype
			jQuery(row).find(".ol-item-documents_area:first").find(".ol-item-document").each(function(){
				file = jQuery(this).find(".ol-item-document-content a").html().toLowerCase();
				if (file.endsWith(".png") || file.endsWith(".jpg") || file.endsWith(".jpeg") ||file.endsWith(".gif") || file.endsWith(".bmp"))
				{
					jQuery(this).addClass("ol-item-document-mime-image");
					return;
				}
				if(file.endsWith(".doc") ||file.endsWith(".odt") || file.endsWith(".docx")){
					jQuery(this).addClass("ol-item-document-mime-document");
					return;
				}
				if(file.endsWith(".pdf")){
					jQuery(this).addClass("ol-item-document-mime-pdf");
					return;
				}
				if(file.endsWith(".zip") || file.endsWith(".rar") || file.endsWith(".tgz") || file.endsWith(".tar") || file.endsWith(".gz"))
				{
					jQuery(this).addClass("ol-item-document-mime-zipped");
					return;
				}
				if(file.endsWith(".html")){
					jQuery(this).addClass("ol-item-document-mime-html");
					return;
				}
				jQuery(this).addClass("ol-item-document-mime-unknown");
				
				
				
				//jQuery(this).find(".ol-item-document-content").addClass(".ol-item-document-mime");
			});
			
			
		},		
		changePriorityClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Change priority Click");
			}
			var priority_literal = jQuery(event.target);
			main_row = OrderedListHandler.Util.getMainRow(event.target)
			main_row_config = OrderedListHandler.Util.getConfig(main_row)
			OrderedListHandler.Util.showSlider(priority_literal, main_row_config.priority, $(main_row).attr("id"));			
		},		
		priorityChanged: function(row_id, value){
			config = OrderedListHandler.Util.getConfig($("#"+row_id))
			//Change priority in database
			OrderedListHandler.Util.call([config.callback,'priority',config.pname,config.id,value],'flash');
			//Flash area
			jQuery('.flash').slideDown()
			
			//change the priority on row config
			config.priority = value;
			$("#"+row_id).attr("config", JSON.stringify(config));
            //OrderedListHandler.refresh_menu();
		},		
		listStateClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Tab item Click");
			}
			//get the config in the "config" attribute of the DOM element:

			config_str = $(event.target).attr('config') ;
			//convert to javascript object:
			config = eval('('+config_str+')');	
			// Reload page
			window.location.href=config.url;	
		},		
		sortUpdate: function(a,b) {
			var row_config = OrderedListHandler.Util.getConfig(b.item);
			var area = jQuery(a.target).parents(".ol-item-list-sortable:first");
		    var dragEls = jQuery(area).children();
		    //var dragEls = jQuery(a.target).children();
		    var els = row_config.pid+'?order=';
		    jQuery.each(dragEls, function () {
				var item_config = OrderedListHandler.Util.getConfig(this);
		        var cur_id = item_config.sid; //jQuery(this).attr('id').split('item_');
		        //cur_id.shift();
		        els += cur_id+",";
		    });
		    var params=els.substring(0, els.length-1)
		    ajax(OrderedListHandler.Util.prepareURL([config.callback,'sort',row_config.pname])+params,'flash');
		},		
		setMenuCounter: function(item, value){
			
			//usage: OrderedListHandler.setMenuCounter(event.currentTarget, "27");
			// Even insde of the object we need to call with the variable name because of the differents ambits.
			$(item).find(".ol-queue-count").html(value);
		},		
		addItemFromPattern: function(params){
			if (OrderedListHandler.DEBUG == true){
				console.log(inspect(params));
			}
			//clone the item pattern
			newitem = $(".ol-item-row-pattern").clone(true);
			
			//set id
			newitem.attr("id", params.id);
			
			//set priority, pid and tid
			config = OrderedListHandler.Util.getConfig(newitem);
			config.sid = params.sid;
			config.pid = params.pid;	
			config.tid = params.tid;
			config.pid = params.pid;			
			config.id = params.id;			
			config.priority = params.priority;			
			newitem.attr("config", JSON.stringify(config));
			
			//set order
			jQuery(newitem).find(".ol-item-order").html(params.order);
			
			//set author
			try {
				jQuery(newitem).find(".ol-item-author").html(params.creator);
			} catch(err) {
				// Do nothing
			}
			//set title
			jQuery(newitem).find(".ol-item-title").html(params.title);
			
			//set description
			jQuery(newitem).find(".ol-item-description").html(params.description);
			//set responsible
			try {
				jQuery(newitem).find(".ol-item-responsible").html(params.responsible);
			} catch(err) {
				// Do nothing
			}
			// set dates
			try {
				var date_elem=jQuery(newitem).find("#ini_date_0");
				date_elem.html(params.ini_date);
				date_elem.attr("id","ini_date_"+params.id);
			} catch(err) {
				// Do nothing
			}
			try {
				var date_elem=jQuery(newitem).find("#end_date_0");
				date_elem.html(params.end_date);
				date_elem.attr("id","end_date_"+params.id);
			} catch(err) {
				// Do nothing
			}
			
			//set tags			
			for(var i in params.tags) {	
				var newtag = jQuery(".ol-item-tag-pattern").clone(true);
				newtag.find(".ol-item-tag-content").html(params.tags[i]);
				newtag.removeClass("ol-item-tag-pattern");
				newtag.removeClass("ol-hidden");
				jQuery(newitem).find(".ol-item-tags-td:first").append(newtag);			    
			}	
			
			jQuery(newitem).addClass("ol-item-row");
			jQuery(newitem).removeClass("ol-hidden");
			jQuery(newitem).removeClass("ol-item-row-pattern");
			
			
			//set the proper ids
			jQuery(newitem).find(".ol-item-title:first").attr("id","title_"+config.tid);
			jQuery(newitem).find(".ol-item-creator:first").attr("id","author_"+config.tid);
			jQuery(newitem).find(".ol-item-tags_area:first").attr("id","tags_area_"+config.tid);
			jQuery(newitem).find(".ol-item-add-tag:first").attr("id","tags_area_btn_"+config.tid);
			jQuery(newitem).find(".ol-item-responsible:first").attr("id","responsible_"+config.tid);
			jQuery(newitem).find(".ol-a-add-btn:first").attr("id","responsible_btn_"+config.tid);
			jQuery(newitem).find(".ol-item-comments_area:first").attr("id","comments_area_"+config.tid);
			jQuery(newitem).find(".ol-item-add-comment:first").attr("id","comments_area_btn_"+config.tid);
			
			//prepend to list			
			
			if(params.vid==0) {
				jQuery("#olContentList").append(newitem);
			} else {
				jQuery("#item_area_"+params.vid).append(newitem);
			}
			
			//set the config
			OrderedListHandler.configureRow(0, newitem);
			
			//we have to change the priority colour after append to the list because javascript cannot acces by id to the element.
			try {
				OrderedListHandler.Util.change_priority(params.id, 1, params.priority);	
			} catch(err) {
				// Do nothing
			}				
			
            OrderedListHandler.refresh_menu();	
		},		
		addItemClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Add item Click");
			}
			
			config = OrderedListHandler.Util.getConfig($(event.target));
            jQuery('#'+config.div_id).fadeIn();
			OrderedListHandler.Util.call([config.callback],'c'+config.div_id);
		},			
		addSubitemClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Add subitem Click");
			}
			var main_row = OrderedListHandler.Util.getMainRow(event.target);
			var config = OrderedListHandler.Util.getConfig(main_row);
            jQuery('#'+config.div_id).fadeIn();
			OrderedListHandler.Util.call([config.modal,'add_child',config.id,config.tid],'c'+config.div_id);
		},	
		addItem: function(data){
			var params = JSON.parse(data);
			OrderedListHandler.Util.clean_modal('#'+params.div_id);
			//jQuery('#'+params.div_id).hide();
			OrderedListHandler.Util.clean_modal('#'+params.div_id);
			OrderedListHandler.addItemFromPattern(params.data);

            OrderedListHandler.refresh_menu();
		},		
		deleteItemClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Borrar item clicked");	
			}

			if (confirm(OrderedListHandler.literals.askDeleteItem)){
				var main_row = OrderedListHandler.Util.getMainRow(event.target)
				var config = OrderedListHandler.Util.getConfig(main_row);
				OrderedListHandler.Util.call([config.callback,config.delete_item,config.pname,config.id,config.tid],'flash');
	            jQuery('#item_'+config.tid).remove();
	            jQuery('#flash').show();

	            OrderedListHandler.refresh_menu();
		    } 			
		},		
		editItemClick: function (event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Delete Click");
			}
			var main_row = OrderedListHandler.Util.getMainRow(event.target);
			var config = OrderedListHandler.Util.getConfig(main_row);
            jQuery('#'+config.div_id).fadeIn();
			OrderedListHandler.Util.call([config.modal,'edit',config.tid],'c'+config.div_id);
		},
		editItem: function(data){
			var params = JSON.parse(data);
			OrderedListHandler.Util.clean_modal('#'+params.div_id);
			// Edit by tipe
			if (params.data.type == 'roadmap') {
				jQuery('#title_'+params.data.tid).html(params.data.title);
				jQuery('#desc_area_'+params.data.tid).html(params.data.description);
				jQuery('#ini_date_'+params.data.tid).html(params.data.ini_date);
				jQuery('#end_date_'+params.data.tid).html(params.data.end_date);	
			} else {
				jQuery('#title_'+params.data.tid).html(params.data.title);
				jQuery('#desc_area_'+params.data.tid).html(params.data.description);
			}	
		},		
		/** ASSIGN TO FUNCTIONS**/
		assignToClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Asignar a, clicked");	
			}
			main_row = OrderedListHandler.Util.getMainRow(event.target);
			config = OrderedListHandler.Util.getConfig(main_row);
            jQuery('#'+config.div_id).fadeIn();
			OrderedListHandler.Util.call([config.modal,'responsible',config.pid,config.id,config.tid],'c'+config.div_id);
		},		
		assignResponsible: function(data){
			var params = JSON.parse(data);
			OrderedListHandler.Util.clean_modal('#'+params.div_id);
			//jQuery('#'+params.div_id).hide();
			jQuery('#responsible_'+params.data.tid).html(params.data.responsible);

            OrderedListHandler.refresh_menu();
		},		
		menuItemClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Menu item Click");
			}
			//get the config in the "config" attribute of the DOM element:
			config_str = $(event.currentTarget).find(".ol-queue-name").attr('config') ;
			//convert to javascript object:
			config = eval('('+config_str+')');		
			// Reload page
			window.location.href=config.url;	
		},		
		menuItemHoverIn: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Menu item IN");
			}
			
//			//get the config in the "config" attribute of the DOM element:
//			config_str = $(event.currentTarget).find(".ol-queue-name").attr('config') ;	
//			//convert to javascript object:
//			config = eval('('+config_str+')');
		},
		menuItemHoverOut: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Menu item out");
			}
			//$(event.currentTarget).children("div.ol-queue-menu-btn").html("");
			//$(event.currentTarget).children(".ol-queue-menu-btn").addClass("ol-invisible");
			//console.log("Menu item out");
		},		
		/** BLOCK ITEM FUNCTIONS**/		
		contentItemHoverIn: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Item IN");
			}
			//event_id = $(event.currentTarget).find(".ol-queue-menu-btn").id;
			//$("#object_inspect").html(event_id);
			//console.log(event.target.attr("id"));
			
			//get the config in the "config" attribute of the DOM element:
			config_str = $(event.currentTarget).find(".ol-queue-name").attr('config') ;			
			//convert to javascript object:
			config = eval('('+config_str+')');		
			
			$(event.currentTarget).closest(".ol-content-item").addClass("ol-content-item-hover");			

			
			//$(event.currentTarget).find("#erbuton").html("yepa");
			
			//$(event.currentTarget).children(".ol-queue-menu-btn").removeClass("ol-invisible");
			
		},
		contentItemHoverOut: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Item out");
			}			
			
			$(event.currentTarget).closest(".ol-content-item").removeClass("ol-content-item-hover");
			//$(event.currentTarget).children("div.ol-queue-menu-btn").html("");
			//$(event.currentTarget).children(".ol-queue-menu-btn").addClass("ol-invisible");
			//console.log("Menu item out");
		},
		/** COMMENTS FUNCTIONS**/
		addCommentClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Aniadir comentario, clicked");	
			}
			
			main_row = OrderedListHandler.Util.getMainRow(event.target)
			config = OrderedListHandler.Util.getConfig(main_row)
            jQuery('#'+config.div_id).fadeIn();
			OrderedListHandler.Util.call([config.modal,'comment',config.pid,config.id,config.tid],'c'+config.div_id);			
		},		
		addComment: function(data){
			var params = JSON.parse(data);
			//hide mmodal
			OrderedListHandler.Util.clean_modal('#'+params.div_id);
			//Add comment
			OrderedListHandler.addCommentFromPattern(params.data.tid,params.data.comment);
		},
		addCommentFromPattern: function(id,params){
			if (OrderedListHandler.DEBUG == true){
				console.log(inspect(params));
			}
			//clone the item pattern
			newtag = $(".ol-item-comment-pattern").clone(true);
						
			//set value
			newtag.find(".ol-item-comment").html(params.comment);
			newtag.find(".ol-item-comment-author").html(params.author);
			newtag.find(".ol-item-comment-date").html(params.date);
			
			newtag.removeClass("ol-item-comment-pattern");
			newtag.removeClass("ol-hidden");
			//append to list
			jQuery("#comments_area_"+id).append(newtag);						
		},		
		/** TAGS FUNCTIONS**/
		addTagClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Aniadir tag clicked");	
			}
			main_row = OrderedListHandler.Util.getMainRow(event.target)
			config = OrderedListHandler.Util.getConfig(main_row)
            jQuery('#'+config.div_id).fadeIn();
			OrderedListHandler.Util.call([config.modal,'tag',config.pid,config.id,config.tid],'c'+config.div_id);			
		},		
		addTag: function(data){
			var params = JSON.parse(data);
			//hide mmodal
			OrderedListHandler.Util.clean_modal('#'+params.div_id);			
			//add tags
			for(var i in params.data.tags) {
				OrderedListHandler.addTagFromPattern(params.data.tid,params.data.tags[i]);			    
			}
		},
		addTagFromPattern: function(id,params){
			if (OrderedListHandler.DEBUG == true){
				console.log(inspect(params));
			}
			//clone the item pattern
			newtag = $(".ol-item-tag-pattern").clone(true);
			
			//set id
			newtag.attr("id", 'tag_'+params.id);
			
			//set value
			newtag.find(".ol-item-tag-content").html(params.value);
			
			//change config
			config='{tag:'+params.id+'}'
			newtag.find(".ol-item-tag-delete").attr("config", config);
			
			newtag.removeClass("ol-item-tag-pattern");
			newtag.removeClass("ol-hidden");
			newtag.addClass("ol-item-tag");
			//append to list
			jQuery("#tags_area_"+id).append(newtag);						
		},
		tagClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Tag clicked");	
			}			
		},		
		deleteTagClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Borrar tag clicked");	
			}			

			if (confirm(OrderedListHandler.literals.askDeleteTag)){
				config = OrderedListHandler.Util.getConfig($(event.target));
				tag_id=config.tag;
				
				main_row = OrderedListHandler.Util.getMainRow(event.target)
				main_config = OrderedListHandler.Util.getConfig(main_row)
				
				OrderedListHandler.Util.call([main_config.callback,'delete_tag',main_config.pname,main_config.id,tag_id],'flash');

	            jQuery('#tag_'+tag_id).remove();
	            jQuery('#flash').show();
		    } 
		},		
		tagItemHoverIn: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Tag item IN");
			}
			
			$(event.currentTarget).addClass("ol-item-tag-hover");
			$(event.currentTarget).next().removeClass("ol-invisible");			
		},
		tagItemHoverOut: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Tag item out");
			}
			$(event.currentTarget).removeClass("ol-item-tag-hover");
		},
		deleteTagItemHoverIn: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Delete Tag item IN");
			}
			$(event.currentTarget).addClass("ol-item-tag-hover");			
		},
		deleteTagItemHoverOut: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Tag item out");
			}
			$(event.currentTarget).removeClass("ol-item-tag-hover");
		},
		tagWholeDIVHoverIn: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Tag item out");
			}
			//Do nothing
		},
		tagWholeDIVHoverOut: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Tag item out");
			}
			$(event.currentTarget).children(".ol-item-tag-delete").addClass("ol-invisible");
		},
		/** DOCS FUNCTIONS**/
		addDocClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Aniadir comentario, clicked");	
			}
			
			var main_row = OrderedListHandler.Util.getMainRow(event.target)
			var config = OrderedListHandler.Util.getConfig(main_row)
            jQuery('#'+config.div_id).fadeIn();
			OrderedListHandler.Util.call([config.modal,'file',config.pid,config.id,config.tid],'c'+config.div_id);			
		},		
		addDoc: function(json_data){
			var data=json_data.data
			//Add comment
			OrderedListHandler.addDocFromPattern(data.id,data.params);
		},
		addDocFromPattern: function(id,params){
			if (OrderedListHandler.DEBUG == true){
				console.log(inspect(params));
			}
			
			//clone the item pattern
			newtag = $(".ol-item-doc-pattern").clone(true);
						
			//set value
			newtag.attr("id","doc_"+params.id);
			newtag.find(".ol-item-document-content").attr("title",params.title);
			newtag.find(".ol-item-document-link").attr("href",params.url);
			newtag.find(".ol-item-document-link").html(params.name);
			config="{doc:'"+params.id+"'}"
			newtag.find(".ol-item-document-delete").attr("config", config);
			
			newtag.removeClass("ol-item-doc-pattern");
			newtag.removeClass("ol-hidden");
			//append to list
			jQuery("#documents_area_"+id).append(newtag);	
			OrderedListHandler.configureDocumentsRow(jQuery("#item_"+id));
		},		
		
		documentClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Tag clicked");	
			}			
		},		
		deleteDocumentClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Borrar tag clicked");	
			}			

			if (confirm(OrderedListHandler.literals.askDeleteDocument)){
				config = OrderedListHandler.Util.getConfig($(event.target));
				document_id=config.doc;
				
				main_row = OrderedListHandler.Util.getMainRow(event.target)
				main_config = OrderedListHandler.Util.getConfig(main_row)
				
				OrderedListHandler.Util.call([main_config.callback,'delete_document',main_config.pname,config.id,document_id],'flash');
	            jQuery('#doc_'+document_id).remove();
	            jQuery('#flash').show();
		    } 
		},		
		documentItemHoverIn: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Document item IN");
			}
			
			$(event.currentTarget).addClass("ol-item-document-hover");
			$(event.currentTarget).next().removeClass("ol-invisible");			
		},
		documentItemHoverOut: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Document item out");
			}
			$(event.currentTarget).removeClass("ol-item-document-hover");
		},
		deleteDocumentItemHoverIn: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Delete Tag item IN");
			}
			$(event.currentTarget).addClass("ol-item-document-hover");			
		},
		deleteDocumentItemHoverOut: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Tag item out");
			}
			$(event.currentTarget).removeClass("ol-item-document-hover");
		},
		documentWholeDIVHoverIn: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Tag item out");
			}
			//Do nothing
		},
		documentWholeDIVHoverOut: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Tag item out");
			}
			$(event.currentTarget).children(".ol-item-document-delete").addClass("ol-invisible");
		},
		/** DESCRIPTION FUNCTIONS**/
		itemExpandDescription: function(event){
			main_row = OrderedListHandler.Util.getMainRow(event.target)
			desc_item = main_row.find(".ol-item-description");
			desc_lit = main_row.find(".ol-item-expand-description");

			if(desc_item.hasClass("ol-item-overflow-auto")) {
				desc_item.removeClass("ol-item-overflow-auto");
				desc_item.addClass("ol-item-overflow-visible");
				desc_lit.html(OrderedListHandler.literals.collapse);
			} else {
				desc_item.removeClass("ol-item-overflow-visible");
				desc_item.addClass("ol-item-overflow-auto");
				desc_lit.html(OrderedListHandler.literals.expand);
			}			
		},
		itemChangeDescription: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Change Description");
			}
			// Do nothing
		},
		/** DATE FUNCTIONS **/
		addDateClick: function(event){
			var main_row = OrderedListHandler.Util.getMainRow(event.target);
			var config = OrderedListHandler.Util.getConfig(main_row);
            jQuery('#'+config.div_id).fadeIn();
			OrderedListHandler.Util.call([config.modal,'date',config.tid],'c'+config.div_id);		
		},		
}

OrderedListHandler.Util = {
	createSlider: function(priority, main_row_id){
	    var p = priority
		s=$( "#olSliderSlide" )
		s.slider({ range: "min",
		    min: 1, 
		    max: 6, 
		    orientation: "vertical",
		    init_value: priority,
		    value: priority,
		    animate: true,
		    create: function(event,ui){
				ui.init_value =  priority;
				ui.value = priority;
				//$(slider).parents("#olSliderItem").removeClass("ol-hidden");
				//slider.removeClass("ol-hidden");
				var bindHTML = function() {
		        	$("html").one("click", function (e) {
		                //menuBtn.addClass("gq-invisible");
		                //menuBtn.removeClass("gq-menu-selected");
		        		s.parents("#olSliderItem").removeClass("ol-hidden");
		                //if (countLabel) {
		                //    countLabel.removeClass("gq-hidden")
		                //}
		                s.slider("destroy");
		            });
		        }
		        setTimeout (bindHTML, 1);
			},
		    slide: function(event, ui) {
				
			    OrderedListHandler.Util.change_priority(main_row_id,p,ui.value);
				p = ui.value;
				
			},
			
		    
		    change: function(event, ui) {
				if(event.originalEvent == null){
					return;
				}
			    if (confirm(OrderedListHandler.literals.askChangePriority)){
			    	priority = ui.value;
			    	OrderedListHandler.priorityChanged(main_row_id, ui.value);
					s.parents("#olSliderItem").removeClass("ol-hidden");
	                s.slider("destroy");				    
			    } else {
			    	OrderedListHandler.Util.change_priority(main_row_id,ui.value,priority);
			    	s.slider("value", priority);
				    ui.value = priority;
			    }
				//console.log(slider_1+' '+ui.value);
				//console.log(ui.value); console.log($(this).slider('value'));
				//OrderedListHandler.Util.change_priority('cadaunoelsuyo',slider_1,ui.value);
				//slider_1=ui.value;
			    }
		    });
	    

	},
	showSlider : function(item, priority, main_row_id){
		//jQuery("#olSliderItem").removeClass("ol-hidden");
		slider = jQuery("#olSliderItem");			
		var offset = jQuery(item).offset();	 
		
		OrderedListHandler.Util.createSlider(priority, main_row_id);
        slider.css("top", offset.top);
        slider.css("left", offset.left+10);
        slider.removeClass("ol-hidden");
        //OrderedListHandler.Util.createSlider(priority);
        
        
	},
	getMainRow: function(item){		
		return $(item).parents(".ol-item-row:first");
	},
	getConfig: function(item){
		config_str = $(item).attr('config') ;
		if (OrderedListHandler.DEBUG == true){
			console.log("Configuracion del elemento:" + config_str);
		}
		//convert to javascript object:
		config = eval('('+config_str+')');
		return config;
	},
	call: function(url_params,div_id){
		console.log(OrderedListHandler.Util.prepareURL(url_params))
		ajax(OrderedListHandler.Util.prepareURL(url_params),[],div_id);
	},	
	toggleAll: function(event){
		if (OrderedListHandler.DEBUG == true){
			console.log("ocultar/mostrar todo clicked");
		}
		
		
		//check for the state of the first row (responsible)
		if (jQuery("#olContentList").find(".ol-item-description-row").hasClass("ol-hidden")){
			jQuery("#olContentList").find(".ol-item-responsible-row,.ol-item-description-row,.ol-item-tags-row,.ol-item-comments-row,.ol-item-documents-row").toggleClass("ol-hidden",false);
		} else {
			jQuery("#olContentList").find(".ol-item-responsible-row,.ol-item-description-row,.ol-item-tags-row,.ol-item-comments-row,.ol-item-documents-row").toggleClass("ol-hidden",true);
		}
	},
	toggleAllRow: function(event){
		if (OrderedListHandler.DEBUG == true){
			console.log("ocultar/mostrar todo clicked");
		}
		var parent = OrderedListHandler.Util.getMainRow(event.currentTarget);
		
		//check for the state of the first row (responsible)
		if (jQuery(parent).find(".ol-item-description-row:first").hasClass("ol-hidden")){
			jQuery(parent).find(".ol-item-responsible-row:first,.ol-item-description-row:first,.ol-item-tags-row:first,.ol-item-comments-row:first,.ol-item-documents-row:first").toggleClass("ol-hidden",false);
		} else {
			jQuery(parent).find(".ol-item-responsible-row:first,.ol-item-description-row:first,.ol-item-tags-row:first,.ol-item-comments-row:first,.ol-item-documents-row:first").toggleClass("ol-hidden",true);
		}
	},
	toggleResponsibleRow: function(event){
		if (OrderedListHandler.DEBUG == true){
			console.log("ocultar responsable clicked");
		}
		//jQuery("#object_inspect").html(event.currentTarget.className);
		var parent = OrderedListHandler.Util.getMainRow(event.currentTarget);
		row = $(parent).find(".ol-item-responsible-row:first");
		row.toggleClass("ol-hidden");
		
	},
	toggleDescriptionRow: function (event){
		if (OrderedListHandler.DEBUG == true){
			console.log("ocultar responsable clicked");
		}
		//jQuery("#object_inspect").html(event.currentTarget.className);
		var parent = OrderedListHandler.Util.getMainRow(event.currentTarget);
		row = $(parent).find(".ol-item-description-row:first");
		row.toggleClass("ol-hidden");
		
	},
	toggleTagsRow: function (event){
		if (OrderedListHandler.DEBUG == true){
			console.log("ocultar responsable clicked");
		}
		//jQuery("#object_inspect").html(event.currentTarget.className);
		var parent = OrderedListHandler.Util.getMainRow(event.currentTarget);
		row = $(parent).find(".ol-item-tags-row:first");
		row.toggleClass("ol-hidden");
		
	},
	toggleCommentsRow: function (event){
		if (OrderedListHandler.DEBUG == true){
			console.log("ocultar responsable clicked");
		}
		//jQuery("#object_inspect").html(event.currentTarget.className);
		var parent = OrderedListHandler.Util.getMainRow(event.currentTarget);
		row = $(parent).find(".ol-item-comments-row:first");
		row.toggleClass("ol-hidden");
		
	},
	toggleDocumentsRow: function (event){
		if (OrderedListHandler.DEBUG == true){
			console.log("ocultar responsable clicked");
		}
		//jQuery("#object_inspect").html(event.currentTarget.className);
		var parent = OrderedListHandler.Util.getMainRow(event.currentTarget);
		row = $(parent).find(".ol-item-documents-row:first");
		row.toggleClass("ol-hidden");
		
	},
	change_priority: function (id, previous, current) {
	    var priority=new Array();
	    priority[1]='27';
	    priority[2]='29';
	    priority[3]='7';
	    priority[4]='3';
	    priority[5]='5';
	    priority[6]='13';
	    var priority_lvl=new Array();
	    priority_lvl[1]='Very low';
	    priority_lvl[2]='Low';
	    priority_lvl[3]='Medium';
	    priority_lvl[4]='High';
	    priority_lvl[5]='Very high';
	    priority_lvl[6]='Critical';
	    if ($('#'+id).hasClass('ol-queue-bkgnd-'+priority[previous])) {
	    	$('#'+id).removeClass('ol-queue-bkgnd-'+priority[previous]);
	    }
	    if(current!= 0) {
	    	$('#'+id).addClass("ol-queue-bkgnd-"+priority[current]);
	    }
	    $('#'+id).find(".ol-item-priority-literal:first").text(priority_lvl[current]);
	},
	prepareURL: function (data)	{
		if (data[0].search("%s")) {
			var tmp = new Array();
			for(var i in data) {
				var elem = data[i]

				if (i==0) {
					elem = elem.replace("/%s", "");
				}
				tmp[i] = elem
			}
			data = tmp;
		}
		return data.join("/") + "/";
	},
	showAllRow: function(){
		jQuery('#content').find(".ol-item-responsible-row:first,.ol-item-description-row:first,.ol-item-tags-row:first,.ol-item-comments-row:first").toggleClass("ol-hidden",false);
	},
	clean_modal: function(div_id) {
		jQuery(div_id).hide();
	}
};