OrderedListHandler.modules.priority = {
    options: {
        txt_priority: "Priority",       
        priorities: [{level: 1, css_class: 27, label: "Very low"},
                     {level: 2, css_class: 29, label: "Low"},
                     {level: 3, css_class: 7, label: "Medium"},
                     {level: 4, css_class: 3, label: "High"},
                     {level: 5, css_class: 5, label: "Very high"},
                     {level: 6, css_class: 13, label: "Critical"}]
    },
    actions_section: function(){
        if(!OrderedListHandler.perm.edit){
            return null;
        }
        var element = $("<td />", {"class": "ol-item-priority"});
        var btn_group = $("<div />", {"class": "btn-group"});
        var link = $("<a />", { rel: "tooltip",
                                title: this.options.txt_priority,
                                "class": "btn btn-mini dropdown-toggle",
                                style: "opacity: 0.5; filter:alpha(opacity=50); color:black;",
                                href: "#"});
        $(link).attr("data-toggle", "dropdown");
        $("<i />", {"class": "icon-exclamation-sign"}).appendTo(link);
        $("<span />", {"class": "caret"}).appendTo(link);   
        $(btn_group).append(link);
        var ul = $("<ul />", {"class": "dropdown-menu ol-priority-menu"});
        for(i=0; i<this.options.priorities.length; i++){
            var li = $("<li />");
            var a = $("<a />", {href: "#",
                                "class": "ol-priority-state"}).attr("priority-level", this.options.priorities[i].level);
            a.text(this.options.priorities[i].label);
            $(li).append(a);
            $(ul).append(li);
            delete(li);
            delete(la);
        }
        
        $(btn_group).append(ul);        
        $(element.append(btn_group));
        return element;
    },
    hide_show_section:function(){return null;},
    row_section:function(){return null;},
    
    binds: function(){
        
            jQuery(".ol-priority-state").live({ mouseenter:this.priorityStateEnter,
                                                click: this.priorityStateClick});
                                                
            jQuery(".ol-priority-menu").live({mouseleave:this.priorityStateLeave});
    },
    configure: function(row){    
            config = OrderedListHandler.Util.getConfig(row);
            this.change_priority(row.id, 1, config.priority);        
    },
    priorityChanged: function(row_id, value){
            if (OrderedListHandler.DEBUG){
                console.log("priorityChanged")
            }
            config = OrderedListHandler.Util.getConfig($("#"+row_id))
            //Change priority in database
            OrderedListHandler.Util.call([config.callback,'priority',config.pname,config.id,value],'flash');
            //Flash area
            jQuery('.flash').slideDown()
            
            //change the priority on row config
            config.priority = value;
            $("#"+row_id).attr("config", JSON.stringify(config));
            //OrderedListHandler.refresh_menu();
    },  
    priorityStateClick: function(){
            if (OrderedListHandler.DEBUG){
                console.log("priorityStateClick")
            }
            var main_row_id = ($(this).closest(".ol-item-row").attr("id"));
            var priority_level = $(this).attr("priority-level");
            OrderedListHandler.modules.priority.priorityChanged(main_row_id, priority_level);
        },
        priorityStateEnter: function(event){
            if (OrderedListHandler.DEBUG){
                console.log("priorityStateEnter")
            }
            element = event.currentTarget;
            var priority=new Array();
            priority[1]='27';
            priority[2]='29';
            priority[3]='7';
            priority[4]='3';
            priority[5]='5';
            priority[6]='13';
            
            var priority_level = parseInt(($(element).attr("priority-level")));
            var config = eval('('+$(element).closest(".ol-item-row").attr("config")+')');
            for (var p in priority){
                $(element).closest(".ol-item-row").removeClass("ol-queue-bkgnd-"+priority[p]);
            }           
            $(element).closest(".ol-item-row").addClass("ol-queue-bkgnd-"+priority[priority_level]);
        },
        priorityStateLeave: function(){
            if (OrderedListHandler.DEBUG){
                console.log("priorityStateLeave")
            }
            console.log($(this).attr("priority-level")+" leave");
            var priority=new Array();
            priority[1]='27';
            priority[2]='29';
            priority[3]='7';
            priority[4]='3';
            priority[5]='5';
            priority[6]='13';
            
            var priority_level = $(this).attr("priority-level");            
            var config = eval('('+$(this).closest(".ol-item-row").attr("config")+')');
            for (var p in priority){
                $(this).closest(".ol-item-row").removeClass("ol-queue-bkgnd-"+priority[p]);
            }   
            $(this).closest(".ol-item-row").addClass("ol-queue-bkgnd-"+priority[config.priority]);
        },    
    change_priority: function (id, previous, current) {
        if (OrderedListHandler.DEBUG){
                console.log("change_priority");
            }
        var priority=new Array();
        priority[1]='27';
        priority[2]='29';
        priority[3]='7';
        priority[4]='3';
        priority[5]='5';
        priority[6]='13';
        var priority_lvl=new Array();
        priority_lvl[1]='Very low';
        priority_lvl[2]='Low';
        priority_lvl[3]='Medium';
        priority_lvl[4]='High';
        priority_lvl[5]='Very high';
        priority_lvl[6]='Critical';
        if ($('#'+id).hasClass('ol-queue-bkgnd-'+priority[previous])) {
            $('#'+id).removeClass('ol-queue-bkgnd-'+priority[previous]);
        }
        if(current!= 0) {
            $('#'+id).addClass("ol-queue-bkgnd-"+priority[current]);
        }
        $('#'+id).find(".ol-item-priority-literal:first").text(priority_lvl[current]);
    }
}
