/*
* Este fichero forma parte de openMyWork
*
* Copyright Daniel Gonzalez     <dgzaballos@gmail.com>
* Copyright Jesus Martinez      <jamarcer@gmail.com>
*
* Este fichero se distribuye bajo la licencia GPL según las
* condiciones que figuran en el fichero 'licence' que se acompaña.
* Si se distribuyera este fichero individualmente, DEBE incluirse aquí
* las condiciones expresadas allí.
*
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

//    call: function(url_params,div_id,url_args){
//		if (url_args === undefined) {
//			url_args = [];
//		}

//add "endsWith" Functionality

/*
<div class="ol-item-row" config="{{=item.config}}" id="item_{{=item.id}}">
        <div class="ol-content-item">
            <table>
                <tbody>
                    <tr width="100%">
                        <td class="ol-item-spacer-10"></td>
                        <td class="ol-item-order ol-item-order-handle">{{=item.numeral}}</td>
                        <td class="ol-item-spacer-10"></td>
                        <td class="ol-item-mark-btn"></td>
                        <td class="ol-item-title" id="title_{{=item.id}}">{{=item.name}}</td>
                        
                       
                        
                        <td class="ol-item-show-all-btn" rel="tooltip" title="{{=T('Show')}}"></td>                        
                        <td class="ol-item-description-btn" rel="tooltip" title="{{=T('Description')}}"></td>
                        
                        <td class="ol-item-comments-btn" rel="tooltip" title="{{=T('Comments')}}"></td>
                        <td class="ol-item-documents-btn" rel="tooltip" title="{{=T('Documents')}}"></td>
                        <td class="ol-item-delete-btn" rel="tooltip" title="{{=T('Delete')}}"></td>
                        <td class="ol-item-edit-btn" rel="tooltip" title="{{=T('Edit')}}"></td>
                    </tr>
                    <!---->
                  
                   
                    <tr class="ol-item-description-row">
                        <td></td>
                        <td class="ol-item-description-td">
                            <div class="row-fluid">
                                <div class="span11 row-fluid">
                                    <div class="ol-item-description ol-item-overflow-auto span12" id="desc_area_{{=item.id}}" >{{=XML(item.desc.replace("\n","<br/>"))}}</div>
                                </div>
                                <div class="span1 row-fluid">
                                    <div class="ol-item-expand-description btn btn-mini span12"> <i class="icon-chevron-down"></i> {{=T('expand')}}</div>
                                <!-- <div class="ol-item-change-description">+ {{=T('change')}}</div> -->
                                </div>
                            </div>
                        </td>
                    </tr>   
                                    
                                    
                    
                </tbody>
            </table>
        </div>
        <div class="ol-sub-items-div ui-sortable" id="item_area_{{=item.id}}">
        </div>
    </div>
 */
String.prototype.endsWith = function(str) 
{return (this.match(str+"$")==str)}

function inspect(obj, maxLevels, level)
{
  var str = '', type, msg;

    // Start Input Validations
    // Don't touch, we start iterating at level zero
    if(level == null)  level = 0;

    // At least you want to show the first level
    if(maxLevels == null) maxLevels = 1;
    if(maxLevels < 1)     
        return '<font color="red">Error: Levels number must be > 0</font>';

    // We start with a non null object
    if(obj == null)
    return '<font color="red">Error: Object <b>NULL</b></font>';
    // End Input Validations

    // Each Iteration must be indented
    str += '<ul>';

    // Start iterations for all objects in obj
    for(property in obj)
    {
      try
      {
          // Show "property" and "type property"
          type =  typeof(obj[property]);
          str += '<li>(' + type + ') ' + property + 
                 ( (obj[property]==null)?(': <b>null</b>'):('')) + '</li>';

          // We keep iterating if this property is an Object, non null
          // and we are inside the required number of levels
          if((type == 'object') && (obj[property] != null) && (level+1 < maxLevels))
          str += inspect(obj[property], maxLevels, level+1);
      }
      catch(err)
      {
        // Is there some properties in obj we can't access? Print it red.
        if(typeof(err) == 'string') msg = err;
        else if(err.message)        msg = err.message;
        else if(err.description)    msg = err.description;
        else                        msg = 'Unknown';

        str += '<li><font color="red">(Error) ' + property + ': ' + msg +'</font></li>';
      }
    }

      // Close indent
      str += '</ul>';

    return str;
}

var OrderedListHandler = {
		DEBUG: false,
		HOVERDEBUG: false,
		
		//config vars
		make_sortable: true,
		make_readonly: false,
		refresh_function: '',
		perm: {assignments: false,
		       assign_to: false,
		       tags: false,
		       create_tag: false,
		       delete_tag: false,
		       documents: false,
               create_document: false,
               delete_document: false,
               download_document: false,
               can_close: false,
               add_childs: false,
               comments: false,
               create_comment: false,
               edit: false,
               "delete": false,
               create: false},

        actions_enabled : ["date", "priority"],
        buttons_enabled: ["description", "assignments","comments", "tags", "documents"],
        
		
		
		// literals
 		literals: { //default values,
				askDeleteItem: "Are you sure to delete this item?",
				askDeleteTag: "Are you sure to delete this tag?",
				askChangePriority: "Are you sure to change the priority?",
				askDeleteDocument: "Are you sure to delete this document?",
 		 		//expand: '<i class="icon-chevron-down"></i> expand',
 		 		//collapse: '<i class="icon-chevron-up"></i> collapse',
 		 		txt_show: "Show",
 		 		txt_edit: "Edit",
 		 		txt_delete: "Delete"
 		 		},
 		 		
		init: function(refresh_name, items){
		   
		    if (!items){items = []};
		    
 		 	// refresh function
 		 	if (refresh_name === undefined) {
 		 		this.refresh_function='';
 		 	} else {
 		 		this.refresh_function=refresh_name; 		 		
 		 	}		
	
			//make sortable
			if (OrderedListHandler.make_sortable == true){
				jQuery(".ui-sortable").sortable({update: this.sortUpdate,  placeholder: 'ol-item-placeholder', forcePlaceholderSize:true });
				//jQuery(".ui-sortable").sortable({update: this.sortUpdate, connectWith: ".ui-sortable", placeholder: 'ol-item-placeholder', forcePlaceholderSize:true });
				//to activate sortable and drag 'n drop use this: connectWith: ".ui-sortable",
			}
			
			//make readonly
			/*if(OrderedListHandler.make_readonly == true){
				if (!jQuery(".ol-subitem-add-btn, .ol-item-delete-btn, .ol-item-edit-btn, .ol-item-add-tag, .ol-item-change-description, .ol-item-add-comment, .ol-a-add-btn, .ol-item-add-doc").hasClass("ol-invisible")){
					jQuery(".ol-subitem-add-btn, .ol-item-delete-btn, .ol-item-edit-btn, .ol-item-add-tag, .ol-item-change-description, .ol-item-add-comment, .ol-a-add-btn, .ol-item-add-doc").addClass("ol-invisible");
				}
				jQuery('.ol-item-tag-delete, .ol-item-document-delete').remove();
			}*/
			
			//jQuery("#sortable").sortable({stop: this.sortUpdate });
			jQuery(".ol-queue-container").live("click", this.menuItemClick);
						
			//** ADD TO Bindings **//
			if(this.perm.create){
			 jQuery(".ol-item-add").live("click", this.addItemClick); //add
			}
			
			//** CHANGE Bindings **//
			//jQuery(".ol-item-change-priority").bind("click", this.changePriorityClick); //change priority
			
			
			//** MENU Bindings**//
			jQuery(".ol-queue-container").live({mouseover:this.menuItemHoverIn, mouseleave:this.menuItemHoverOut});
			
			//** ITEM BLOCK Bindings**//
			jQuery(".ol-content-item").live({mouseover: this.contentItemHoverIn, mouseleave: this.contentItemHoverOut});
			
			//** TABS Bindings**//
			jQuery(".ol-list-state-tabs").live("click", this.listStateClick); //delete tag click
			
			//** BUTTONS Bindings**//
			jQuery(".ol-list-show-all-btn").live("click", this.Util.toggleAll);
			jQuery(".ol-item-show-all-btn").live("click", this.Util.toggleAllRow);
			
			if(OrderedListHandler.perm.can_close){
				jQuery(".ol-item-mark-btn").live("click", this.itemCheckedClick);
			}
			
			
			if(this.perm["delete"]){
			jQuery(".ol-item-delete-btn").live("click", this.deleteItemClick);
			}
			if(this.perm.edit){
			jQuery(".ol-item-edit-btn").live("click", this.editItemClick);
			}			
			
			
			//** DATE Bindings**//
						
		     

		     $.each(OrderedListHandler.modules, function(index,module){
		         module.binds();
		     })
                  
             for (var i = 0; i< items.length; i++){
                 $(".ol-item-list-controls").append(this.__createItem(items[i]));
             }
		     
		     
			 OrderedListHandler.configure();
             $("[rel=tooltip]").tooltip();
		},
		configure: function(){            
            //configure each row.
            jQuery(".ol-item-row").each(function(index){
                OrderedListHandler.configureRow(index, this);
            });
        },
        configureRow: function(index, row){
            
            var filas = $(row).find("tr:not(:first)");
            $(filas).toggleClass("ol-hidden", true);
            config = OrderedListHandler.Util.getConfig(row);
            /*if(OrderedListHandler.perm.can_close && !config.close ){
                $(filas).prepend("<td />");
            }*/
            $(filas).addClass("ol-element-row");

            
            $.each(OrderedListHandler.modules, function(index,module){
                 module.configure(row);
             })

            OrderedListHandler.configureColSpanRowSpan(row);
            
            
            
        },
        configureColSpanRowSpan: function(row){
            var rowCount = jQuery(row).find("table:first tr").length;
            var colCount = jQuery(row).find("table:first tr:first td").length;
            //set rowspan
            jQuery(row).find("table:first tr:first .ol-item-spacer").attr('rowspan',rowCount);
            jQuery(row).find("table:first tr:first .ol-item-order").attr('rowspan',rowCount);
            jQuery(row).find("table:first tr:first .ol-item-spacer-10").attr('rowspan',rowCount);
            var subtract = 3;
            config = OrderedListHandler.Util.getConfig(row);
            /*if(OrderedListHandler.perm.can_close && !config.close){
                 subtract= 4; 
            }*/
            //set colspan
            jQuery(row).find("table:first tr:gt(0)").each(function(){
                jQuery(this).find("td:last").attr('colspan', colCount - subtract)//4 because of the 3 rowspan and the space of the td with the mark button
            });

        },
  
		//** MENU FUNCTIONS **//
		refresh_menu: function () {
			if(typeof this.refresh_function == 'function') {
				this.refresh_function();		 			
		 	}
		},
		setMenuCounter: function(item, value){
            
            //usage: OrderedListHandler.setMenuCounter(event.currentTarget, "27");
            // Even insde of the object we need to call with the variable name because of the differents ambits.
            $(item).find(".ol-queue-count").html(value);
        },  
        menuItemClick: function(event){
            if (OrderedListHandler.DEBUG == true){
                console.log("Menu item Click");
            }
            //get the config in the "config" attribute of the DOM element:
            config_str = $(event.currentTarget).find(".ol-queue-name").attr('config') ;
            //convert to javascript object:
            config = eval('('+config_str+')');      
            // Reload page
            window.location.href=config.url;    
        },      
        menuItemHoverIn: function(event){
            if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
                console.log("Menu item IN");
            }
            
//          //get the config in the "config" attribute of the DOM element:
//          config_str = $(event.currentTarget).find(".ol-queue-name").attr('config') ; 
//          //convert to javascript object:
//          config = eval('('+config_str+')');
        },
        menuItemHoverOut: function(event){
            if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
                console.log("Menu item out");
            }
            //$(event.currentTarget).children("div.ol-queue-menu-btn").html("");
            //$(event.currentTarget).children(".ol-queue-menu-btn").addClass("ol-invisible");
            //console.log("Menu item out");
        },      
		//** SORTABLE FUNCTIONS**//
		disableSortable: function (){
			jQuery(".ui-sortable").sortable( "disable" );
			OrderedListHandler.make_sortable = false;
		},
		enableSortable: function (){
			jQuery(".ui-sortable").sortable( "enable" );
			OrderedListHandler.make_sortable = true;
			jQuery(".ui-sortable").sortable({update: OrderedListHandler.sortUpdate });
		},
		sortUpdate: function(a,b) {
            var row_config = OrderedListHandler.Util.getConfig(b.item);
            var area = jQuery(a.target).parents(".ol-item-list-sortable:first");
            var dragEls = jQuery(area).children();
            //var dragEls = jQuery(a.target).children();
            var els = row_config.pid+'?order=';
            jQuery.each(dragEls, function () {
                var item_config = OrderedListHandler.Util.getConfig(this);
                var cur_id = item_config.sid; //jQuery(this).attr('id').split('item_');
                //cur_id.shift();
                els += cur_id+",";
            });
            var params=els.substring(0, els.length-1)
            ajax(OrderedListHandler.Util.prepareURL([config.callback,'sort',row_config.pname])+params,'flash');
        },  
        //** CHECKED FUNCTIONS **//
		itemCheckedClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Check Click");
			}
			main_row = OrderedListHandler.Util.getMainRow(event.target)
			config = OrderedListHandler.Util.getConfig(main_row);
			OrderedListHandler.Util.call([config.callback,config.close_item,config.pname,config.id,config.tid],'flash');
			jQuery('#item_'+config.tid).remove();
			jQuery('#flash').show();
			OrderedListHandler.refresh_menu();
		},		
		

		//** PESTAÑA DE TODOS/ABIERTOS /CERRADOS **//
		listStateClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("listStateClick");
			}
			//get the config in the "config" attribute of the DOM element:

			config_str = $(event.target).attr('config') ;
			//convert to javascript object:
			config = eval('('+config_str+')');	
			// Reload page
			window.location.href=config.url;	
		},		
		__createItem: function(item){
		    /*         <div class="ol-item-row" config="{{=item.config}}" id="item_{{=item.id}}">
        <div class="ol-content-item">
            <table>
                <tbody>
                    <tr width="100%">
                        <td class="ol-item-spacer-10"></td>
                        <td class="ol-item-order ol-item-order-handle">{{=item.numeral}}</td>
                        <td class="ol-item-spacer-10"></td>
                        <td class="ol-item-mark-btn"></td>
                        <td class="ol-item-title" id="title_{{=item.id}}">{{=item.name}}</td>
                        <td class="ol-item-date" id="date_{{=item.id}}">
                            <div class="btn-group">
                                <a rel="tooltip" title="{{=T('Date')}}" class="ol-item-add-date btn btn-mini"  style="opacity: 0.5; filter:alpha(opacity=50); color:black;" href="#">
                                <i class="icon-calendar"></i>
                                {{=T('No date')}}
                                </a>                                                        
                                </div>
                            
                        </td>
                       
                        <!-- zona de acciones -->
                        <!-- fin zona de acciones-->
                        <td class="ol-item-show-all-btn" rel="tooltip" title="{{=T('Show')}}"></td>                        
                        <!-- zona de botones dinamicos -->
                        <!-- fin de zona de botones dinamicos -->
                        <td class="ol-item-delete-btn" rel="tooltip" title="{{=T('Delete')}}"></td>
                        <td class="ol-item-edit-btn" rel="tooltip" title="{{=T('Edit')}}"></td>
                    </tr> 
                </tbody>
            </table>
        </div>
        <div class="ol-sub-items-div ui-sortable" id="item_area_{{=item.id}}">
        </div>
    </div>*/
		    var big_row = $("<div />", {"class": "ol-item-row", id: "item_"+item.tid, config:JSON.stringify(item)});
		    var content_item = $("<div />", {"class": "ol-content-item"});
		    var table = $("<table />");
		    var tbody = $("<tbody />");
		    
		    var tr = $("<tr />",{width: "100%"});
		    
		    //construimos la fila principal
		    //un spacer 
		    $(tr) .append($("<td />", {"class":"ol-item-spacer-10"}));
            $(tr) .append($("<td />", {"class":"ol-item-order ol-item-order-handle"}).text(item.numeral)); //el numeral
            //$(tr) .append($("<td />", {"class":"ol-item-order ol-item-order-handle"}).text("5")); //el numeral
		    $(tr) .append($("<td />", {"class":"ol-item-spacer-10"})); //otro spacer
		    //si tiene permisos para cerrarlo, el boton para cerrar
		    if (this.perm.can_close && !item.close){
		          $(tr).append($("<td />", {"class":"ol-item-mark-btn"}));    
		    }
		    //el titulo
		    $(tr).append($("<td />", {"class":"ol-item-title", id:"title_"+item.tid}).text(item.name));
		    
		    //zona de acciones
		    for(var i = 0; i < this.actions_enabled.length; i++){
		        var ret = this.modules[this.actions_enabled[i]].actions_section(item);
		        if (ret != null){
		          $(tr).append(ret);
		        }
		        delete(ret);
		    }
		    
		    //zona de botones
		    $(tr) .append($("<td />", {"class":"ol-item-show-all-btn", rel:"tooltip", title: OrderedListHandler.literals.txt_show}));
		          
		    //botones aleatorios
		    for(var i = 0; i < this.buttons_enabled.length; i++){
                var ret = this.modules[this.buttons_enabled[i]].hide_show_section(item);
                if (ret != null){
                  $(tr).append(ret);
                }
                delete(ret);
            }
		    //botones de editar y borrar
		    if(this.perm.edit){
		      $(tr) .append($("<td />", {"class":"ol-item-edit-btn", rel:"tooltip", title: OrderedListHandler.literals.txt_edit}));
		    }
		    if(this.perm["delete"]){
		      $(tr).append($("<td />", {"class":"ol-item-delete-btn", rel:"tooltip", title: OrderedListHandler.literals.txt_delete}))
		    }
            $(tr).appendTo(tbody);
		    delete(tr);
		    
		    var modules = this.actions_enabled.concat(this.buttons_enabled);
		    for(var i = 0; i < modules.length; i++){
                var ret = this.modules[modules[i]].row_section(item);
                if (ret != null){
                  $(tbody).append(ret);
                }
                delete(ret);
            }
            //el item principal ya esta listo
            $(table).append(tbody)
                    .appendTo(content_item);
                    
            var children_area = $("<div />", {"class": "ol-sub-items-div ui-sortable", id: "item_area_"+item.tid});
            if (item.children && item.children.length > 0){
                for (var i=0; i<item.children.length;i++){
                    $(children_area).append(this.__createItem(item));
                }
                
            }
            $(content_item) .append(children_area)
                            .appendTo(big_row);
            return big_row;

		},
		addItemFromPattern: function(params){
			if (OrderedListHandler.DEBUG == true){
				console.log(inspect(params));
			}
			//clone the item pattern
			newitem = $(".ol-item-row-pattern").clone(true);
			
			//set id
			newitem.attr("id", params.id);
			
			//set priority, pid and tid
			config = OrderedListHandler.Util.getConfig(newitem);
			config.sid = params.sid;
			config.pid = params.pid;	
			config.tid = params.tid;
			config.pid = params.pid;			
			config.id = params.id;			
			config.priority = params.priority;			
			newitem.attr("config", JSON.stringify(config));
			
			//set order
			jQuery(newitem).find(".ol-item-order").html(params.order);
			
			//set author
			try {
				jQuery(newitem).find(".ol-item-author").html(params.creator);
			} catch(err) {
				// Do nothing
			}
			//set title
			jQuery(newitem).find(".ol-item-title").html(params.title);
			
			//set description
			jQuery(newitem).find(".ol-item-description").html(params.description);
			//set responsible
			try {
				jQuery(newitem).find(".ol-item-responsible").html(params.responsible);
			} catch(err) {
				// Do nothing
			}
			// set dates
			try {
				var date_elem=jQuery(newitem).find("#ini_date_0");
				date_elem.html(params.ini_date);
				date_elem.attr("id","ini_date_"+params.id);
			} catch(err) {
				// Do nothing
			}
			try {
				var date_elem=jQuery(newitem).find("#end_date_0");
				date_elem.html(params.end_date);
				date_elem.attr("id","end_date_"+params.id);
			} catch(err) {
				// Do nothing
			}
			
			//set tags			
			for(var i in params.tags) {	
				var newtag = jQuery(".ol-item-tag-pattern").clone(true);
				newtag.find(".ol-item-tag-content").html(params.tags[i]);
				newtag.removeClass("ol-item-tag-pattern");
				newtag.removeClass("ol-hidden");
				jQuery(newitem).find(".ol-item-tags-td:first").append(newtag);			    
			}	
			
			jQuery(newitem).addClass("ol-item-row");
			jQuery(newitem).removeClass("ol-hidden");
			jQuery(newitem).removeClass("ol-item-row-pattern");
			
			
			//set the proper ids
			jQuery(newitem).find(".ol-item-title:first").attr("id","title_"+config.tid);
			jQuery(newitem).find(".ol-item-creator:first").attr("id","author_"+config.tid);
			jQuery(newitem).find(".ol-item-tags_area:first").attr("id","tags_area_"+config.tid);
			jQuery(newitem).find(".ol-item-add-tag:first").attr("id","tags_area_btn_"+config.tid);
			jQuery(newitem).find(".ol-item-responsible:first").attr("id","responsible_"+config.tid);
			jQuery(newitem).find(".ol-a-add-btn:first").attr("id","responsible_btn_"+config.tid);
			jQuery(newitem).find(".ol-item-comments_area:first").attr("id","comments_area_"+config.tid);
			jQuery(newitem).find(".ol-item-add-comment:first").attr("id","comments_area_btn_"+config.tid);
			
			//prepend to list			
			
			if(params.vid==0) {
				jQuery("#olContentList").append(newitem);
			} else {
				jQuery("#item_area_"+params.vid).append(newitem);
			}
			
			//set the config
			OrderedListHandler.configureRow(0, newitem);
			
			//we have to change the priority colour after append to the list because javascript cannot acces by id to the element.
			try {
				OrderedListHandler.modules.priority.change_priority(params.id, 1, params.priority);	
			} catch(err) {
				// Do nothing
			}				
			
            OrderedListHandler.refresh_menu();	
		},		
		addItemClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Add item Click");
			}
			
			config = OrderedListHandler.Util.getConfig($(event.target));
            //jQuery('#'+config.div_id).fadeIn();
            jQuery('#'+config.div_id).modal('show');
			OrderedListHandler.Util.call([config.callback],'c'+config.div_id);
		},	
		addItem: function(data){
            var params = JSON.parse(data);
            OrderedListHandler.Util.clean_modal('#'+params.div_id);
            //jQuery('#'+params.div_id).hide();
            //OrderedListHandler.Util.clean_modal('#'+params.div_id);
            //OrderedListHandler.addItemFromPattern(params.data);
            newitem = OrderedListHandler.__createItem(params.data);
            
            if(!params.data.vid || params.data.vid==0) {
                jQuery(".ol-item-list-controls").append(newitem);
                
            } else {
                jQuery("#item_area_"+params.data.vid).append(newitem);
            }
                         
            OrderedListHandler.refresh_menu();
            OrderedListHandler.configureRow(null, $("#item_"+params.data.tid).get(0));
        },  		
		
			
		deleteItemClick: function(event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Borrar item clicked");	
			}

			if (confirm(OrderedListHandler.literals.askDeleteItem)){
				var main_row = OrderedListHandler.Util.getMainRow(event.target)
				var config = OrderedListHandler.Util.getConfig(main_row);
				OrderedListHandler.Util.call([config.callback,config.delete_item,config.pname,config.id,config.tid],'flash');
	            jQuery('#item_'+config.tid).remove();
	            jQuery('#flash').show();

	            OrderedListHandler.refresh_menu();
		    } 			
		},		
		editItemClick: function (event){
			if (OrderedListHandler.DEBUG == true){
				console.log("Delete Click");
			}
			var main_row = OrderedListHandler.Util.getMainRow(event.target);
			var config = OrderedListHandler.Util.getConfig(main_row);
            //jQuery('#'+config.div_id).fadeIn();
            jQuery('#'+config.div_id).modal("show");
			OrderedListHandler.Util.call([config.modal,'edit',config.tid],'c'+config.div_id);
		},
		editItem: function(data){
			var params = JSON.parse(data);
			OrderedListHandler.Util.clean_modal('#'+params.div_id);
			// Edit by tipe
			if (params.data.type == 'roadmap') {
				jQuery('#title_'+params.data.tid).html(params.data.title);
				jQuery('#desc_area_'+params.data.tid).html(OrderedListHandler.Util.parseNL(params.data.description));
				jQuery('#ini_date_'+params.data.tid).html(params.data.ini_date);
				jQuery('#end_date_'+params.data.tid).html(params.data.end_date);
				
			} else {
				jQuery('#title_'+params.data.tid).html(params.data.title);
				jQuery('#desc_area_'+params.data.tid).html(OrderedListHandler.Util.parseNL(params.data.description));
				jQuery('#date_'+params.data.tid).html(params.data.date);
			}	
		},		
		
		
		/** BLOCK ITEM FUNCTIONS**/		
		contentItemHoverIn: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Item IN");
			}
			//event_id = $(event.currentTarget).find(".ol-queue-menu-btn").id;
			//$("#object_inspect").html(event_id);
			//console.log(event.target.attr("id"));
			
			//get the config in the "config" attribute of the DOM element:
			config_str = $(event.currentTarget).find(".ol-queue-name").attr('config') ;			
			//convert to javascript object:
			config = eval('('+config_str+')');		
			
			$(event.currentTarget).closest(".ol-content-item").addClass("ol-content-item-hover");			

			
			//$(event.currentTarget).find("#erbuton").html("yepa");
			
			//$(event.currentTarget).children(".ol-queue-menu-btn").removeClass("ol-invisible");
			
		},
		contentItemHoverOut: function(event){
			if (OrderedListHandler.DEBUG == true & OrderedListHandler.HOVERDEBUG == true){
				console.log("Item out");
			}			
			
			$(event.currentTarget).closest(".ol-content-item").removeClass("ol-content-item-hover");
			//$(event.currentTarget).children("div.ol-queue-menu-btn").html("");
			//$(event.currentTarget).children(".ol-queue-menu-btn").addClass("ol-invisible");
			//console.log("Menu item out");
		}
				
			
}
OrderedListHandler.modules = {};

OrderedListHandler.Util = {
	"getMainRow": function(item){		
		return $(item).parents(".ol-item-row:first");
	},
	getConfig: function(item){
		config_str = $(item).attr('config') ;
		if (OrderedListHandler.DEBUG == true){
			console.log("Configuracion del elemento:" + config_str);
		}
		//convert to javascript object:
		//config = JSON.parse(config_str);
		config = eval('('+config_str+')');
		return config;
	},
	call: function(url_params,div_id){
		//console.log(OrderedListHandler.Util.prepareURL(url_params))
		ajax(OrderedListHandler.Util.prepareURL(url_params),[],div_id);
	},	
	toggleAll: function(event){
		if (OrderedListHandler.DEBUG == true){
			console.log("ocultar/mostrar todo clicked");
		}
		
		
		//check for the state of the first row
		if (jQuery("#olContentList").find(".ol-element-row:first").hasClass("ol-hidden")){
		    $("#olContentList").find(".ol-element-row").toggleClass("ol-hidden", false);
			//jQuery("#olContentList").find(".ol-item-responsible-row,.ol-item-description-row,.ol-item-tags-row,.ol-item-comments-row,.ol-item-documents-row").toggleClass("ol-hidden",false);
		} else {
		    $("#olContentList").find(".ol-element-row").toggleClass("ol-hidden", true);
			//jQuery("#olContentList").find(".ol-item-responsible-row,.ol-item-description-row,.ol-item-tags-row,.ol-item-comments-row,.ol-item-documents-row").toggleClass("ol-hidden",true);
		}
	},
	toggleAllRow: function(event){
		if (OrderedListHandler.DEBUG == true){
			console.log("ocultar/mostrar todo clicked");
		}
		var parent = $(event.currentTarget).closest("table");
		//parent = OrderedListHandler.Util.getMainRow(event.currentTarget);
		
		//check for the state of the first row
		if (jQuery(parent).find(".ol-element-row:first").hasClass("ol-hidden")){
		    $(parent).find(".ol-element-row").toggleClass("ol-hidden", false);
			//jQuery(parent).find(".ol-item-responsible-row:first,.ol-item-description-row:first,.ol-item-tags-row:first,.ol-item-comments-row:first,.ol-item-documents-row:first").toggleClass("ol-hidden",false);
		} else {
		    $(parent).find(".ol-element-row").toggleClass("ol-hidden", true);
			//jQuery(parent).find(".ol-item-responsible-row:first,.ol-item-description-row:first,.ol-item-tags-row:first,.ol-item-comments-row:first,.ol-item-documents-row:first").toggleClass("ol-hidden",true);
		}
	},	
	prepareURL: function (data)	{
		if (data[0].search("%s")) {
			var tmp = new Array();
			for(var i in data) {
				var elem = data[i];

				if (i==0) {
					elem = elem.replace("/%s", "");
				}
				tmp[i] = elem;
			}
			data = tmp;
		}
		return data.join("/") + "/";
	},
	showAllRow: function(){
		jQuery('#content').find(".ol-item-responsible-row:first,.ol-item-description-row:first,.ol-item-tags-row:first,.ol-item-comments-row:first").toggleClass("ol-hidden",false);
	},
	clean_modal: function(div_id) {
		jQuery(div_id).modal("hide");
	},
	parseNL: function(str) {
		var txt = str.replace(/\n/g, "<br />")
		return txt;
	}
};